/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/coord.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:33:11 $
 * $Log: coord.c,v $
 *	Revision 1.2  1993/10/24  18:33:11  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:38:54  kawamoto
 *	version 2.24 first cvs importing
 */

#include <sys/xstart.h>
#include "dedit.h"
#include "console.h"
#include "error.h"
#include "coord.h"

char path_name[128];

static char *colorName[10] =
{
  "BLACK", "COLOR1", "COLOR2", "COLOR3",
  "PAPER", "PEN", "PAPCUR", "PENCUR",
  "LINE1", "LINE2"
};

static void SaveCoordination(void)
{
  int fd, number, length, value;
  char buffer[32];

  Assigned_path(path_name, 1);
  if ((fd = CREATE(path_name, 0x20)) < 0)
    return;
  for (number = 0; number < 10; ++number)
    {
      strcpy(buffer, colorName[number]);
      length = strlen(buffer);
      buffer[length++] = ' ';
      buffer[length++] = ' ';
      buffer[length++] = ' ';
      buffer[length++] = ' ';
      buffer[ 7] = '=';
      buffer[ 8] = ' ';
      value = (color[number] >> 6) & 31;
      buffer[ 9] = (value / 10) ? (value / 10 + '0') : ' ';
      buffer[10] = value % 10 + '0';
      buffer[11] = ' ';
      value = (color[number] >> 11) & 31;
      buffer[12] = (value / 10) ? (value / 10 + '0') : ' ';
      buffer[13] = value % 10 + '0';
      buffer[14] = ' ';
      value = (color[number] >> 1) & 31;
      buffer[15] = (value / 10) ? (value / 10 + '0') : ' ';
      buffer[16] = value % 10 + '0';
      buffer[17] = ' ';
      value = (color[number]) & 1;
      buffer[18] = value + '0';
      buffer[19] = '\n';
      buffer[20] = 0;
      FPUTS(buffer, fd);
    }
  SaveFunctionCoordinations(fd);
  CLOSE(fd);
}

static int
open_deditcoo (void)
{
  static const char* deditcoo = "\\.deditcoo";
  char* home = getenv ("HOME");
  int fd;

  if (home && strlen (home) > 100)
    home = NULL;
  if (home)
    {
      strcat (strcpy (path_name, home), deditcoo);
      if ((fd = OPEN(path_name, 0)) >= 0)
	return fd;
    }
  strcat (strcpy (path_name, _procp->exe_path), deditcoo);
  if ((fd = OPEN(path_name, 0)) < 0 && home)
    strcat (strcpy (path_name, home), deditcoo);
  return fd;
}

void LoadCoordination(void)
{
  int fd, number, length = 0;
  struct INPPTR in;

  if ((fd = open_deditcoo ()) < 0)
    return;
  in.max = 255;
  while (FGETS(&in, fd))
    {
      if (in.buffer[0] == 0x1a)
	break;
      if (in.length == 0)
	break;
      if (in.length == 255)
	break;
      for (number = 0; number < 10; number++)
	{
	  length = strlen(colorName[number]);
	  if (strncmp(colorName[number], in.buffer, length))
	    {
	      LoadFunctionCoordination(in.buffer);
	      continue;
	    }
	  if (in.buffer[length] == ' ' || in.buffer[length] == '=')
	    break;
	}
      if (number == 10)
	continue;
      while (in.buffer[length] == ' ' || in.buffer[length] == '=')
	++length;
      color[number] = atoi(in.buffer + length) << 6;
      while (in.buffer[length] != ' ')
	++length;
      while (in.buffer[length] == ' ')
	++length;
      color[number] += atoi(in.buffer + length) << 11;
      while (in.buffer[length] != ' ')
	++length;
      while (in.buffer[length] == ' ')
	++length;
      color[number] += atoi(in.buffer + length) << 1;
      while (in.buffer[length] != ' ')
	++length;
      while (in.buffer[length] == ' ')
	++length;
      color[number] += atoi(in.buffer + length);
    }
  CLOSE(fd);
}

#if 0
void SetCoordinationPath(const char *name)
{
  int offset, length, period_offset;

  strcpy(path_name, name);
  length = strlen(path_name);
  period_offset = length;
  for (offset = length - 1; offset >= 0; --offset)
    {
      if (path_name[offset] == '.')
	{
	  period_offset = offset;
	  break;
	}
      if (path_name[offset] == '/' ||
	  path_name[offset] == '\\')
	break;
    }
  strcpy(path_name + period_offset, ".coo");
}
#endif

static void sampleDraw(int x, int y, int width, int code)
{
  struct TXFILLPTR bufFill;

  x *= 8;
  y *= 16;
  width *= 8;

  bufFill.x = x;
  bufFill.y = y;
  bufFill.x1 = width;
  bufFill.y1 = 16;
  bufFill.vram_page = 0;
  bufFill.fill_patn = (code & 1) ? 0xffff : 0;
  TXFILL(&bufFill);
  bufFill.vram_page = 1;
  bufFill.fill_patn = (code & 2) ? 0xffff : 0;
  TXFILL(&bufFill);
  bufFill.vram_page = 2;
  bufFill.fill_patn = (code & 4) ? 0xffff : 0;
  TXFILL(&bufFill);
  bufFill.vram_page = 3;
  bufFill.fill_patn = (code & 8) ? 0xffff : 0;
  TXFILL(&bufFill);
}

static void redraw()
{
  char buffer[11];
  int number, value;

  buffer[ 2] = ' ';
  buffer[ 5] = ' ';
  buffer[ 8] = ' ';
  buffer[10] = 0;
  for (number = 0; number < 10; ++number)
    {
      value = (color[number] >> 6) & 31;
      buffer[ 0] = (value / 10) ? (value / 10 + '0') : ' ';
      buffer[ 1] = value % 10 + '0';
      value = (color[number] >> 11) & 31;
      buffer[ 3] = (value / 10) ? (value / 10 + '0') : ' ';
      buffer[ 4] = value % 10 + '0';
      value = (color[number] >> 1) & 31;
      buffer[ 6] = (value / 10) ? (value / 10 + '0') : ' ';
      buffer[ 7] = value % 10 + '0';
      value = (color[number]) & 1;
      buffer[ 9] = value + '0';
      Print(50, 10 + number, (uchar *)buffer);
    }
}

static void pre(void)
{
  int number, code;

  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  FNCKEYST(2, MesFKeyReadC);
  FNCKEYST(3, MesFKeyWriteC);
  B_LOCATE(26, 3);
  B_PRINT("\33[36m[[[ \33[35mb@b \33[36m]]]");
  B_LOCATE(36, 8);
  B_PRINT(MesRGB);
  Window(36, 10, 24, 10);
  B_LOCATE(34, 21);
  B_PRINT(MesValueUpDown);
  B_LOCATE(31, 22);
  B_PRINT(MesCurs);
  B_PRINT(MesCursLURD);
  B_LOCATE(32, 23);
  B_PRINT(MesRetESC);
  B_COLOR(3);
  B_CUROFF();
  for (number = 0; number < 10; ++number)
    {
      Print(36, 10 + number, (uchar *)colorName[number]);
      for (code = 0; code < 16; ++code)
	if (table[code] == number)
	  break;
      if (code == 16)
	code = 0;
      sampleDraw(44, 10 + number, 4, code);
    }
  redraw();
}

static void post(void)
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  Clear23();
  NulFuncKey();
}

#define cursor(x, y) CurXor(x, y, (x == 59) ? 0 : 3)

void ColorCoordination(void)
{
  int curX, curY;
  int lastCurX, lastCurY;
  int c, i;
  int changed;
  int value;
  char buffer[3];

  pre();
  curX = 50;
  curY = 10;
  changed = 0;
  buffer[2] = 0;
  while (1)
    {
      lastCurX = curX;
      lastCurY = curY;
      cursor(curX, curY);
      switch (c = GetKey())
	{
	case 0x3d:/* RIGHT */
	  if ((curX += 3) == 62)
	    curX = 59;
	  break;
	case 0x1d:/* CR */
	case 0x4e:/* ENTER */
	  curX = 50;
	  if (++curY == 20)
	    curY = 10;
	  break;
	case 0x3e:/* DOWN */
	  if (++curY == 20)
	    curY = 19;
	  break;
	case 0x3b:/* LEFT */
	  if ((curX -= 3) == 47)
	    curX = 50;
	  break;
	case 0x0f:/* BS */
	  if ((curX -= 3) != 47)
	    break;
	  curX = 59;
	  if (--curY != 9)
	    break;
	  curY = 10;
	  curX = 50;
	  break;
	case 0x3c:/* UP */
	  if (--curY == 9)
	    curY = 10;
	  break;
	case 0x38:/* ROLL UP */
	case 0x39:/* ROLL DOWN */
	  value = color[curY - 10];
	  switch (curX)
	    {
	    case 50:
	      value >>= 6;
	      value &= 31;
	      break;
	    case 53:
	      value >>= 11;
	      value &= 31;
	      break;
	    case 56:
	      value >>= 1;
	      value &= 31;
	      break;
	    case 59:
	      value &= 1;
	      break;
	    }
	  if (c == 0x38 /* ROLL UP */)
	    {
	      if (++value == 32)
		value = 31;
	      if (curX == 59 && value == 2)
		value = 1;
	    }
	  else
	    {
	      if (--value == -1)
		value = 0;
	    }
	  buffer[ 0] = (value / 10) ? (value / 10 + '0') : ' ';
	  buffer[ 1] = value % 10 + '0';
	  switch (curX)
	    {
	    case 50:
	      color[curY - 10] &= 0xf83f;
	      color[curY - 10] |= value << 6;
	      break;
	    case 53:
	      color[curY - 10] &= 0x07ff;
	      color[curY - 10] |= value << 11;
	      break;
	    case 56:
	      color[curY - 10] &= 0xffc1;
	      color[curY - 10] |= value << 1;
	      break;
	    case 59:
	      buffer[ 0] = value + '0';
	      buffer[ 1] = 0;
	      color[curY - 10] &= 0xfffe;
	      color[curY - 10] |= value;
	      break;
	    }
	  cursor(curX, curY);
	  Print(curX, curY, (uchar *)buffer);
	  for (i = 0; i < 16; ++i)
	    TPALET2(i, color[table[i]]);
	  changed = 1;
	  continue;
	case 0x36:/* HOME */
	  curX = 50;
	  curY = 10;
	  break;
	case 0x01:/* ESC */
	  c = ShiftKey;
	  if (changed)
	    {
	      B_LOCATE(20, 29);
	      B_PRINT("\33[36mJ[pbg͕ύXĂ܂B"
		      "{ɏI܂iy/njH ");
	      i = GetKey();
	      B_LOCATE(0, 29);
	      B_ERA_AL();
	      B_CUROFF();
	      if (i != 0x16)
		break;
	    }
	  if (c)
	    {
	      Post();
	      exit(0);
	    }
	  post();
	  return;
	case 0x64:/* F2 */
	  cursor(curX, curY);
	  LoadCoordination();
	  redraw();
	  changed = 0;
	  continue;
	case 0x65:/* F3 */
	  SaveCoordination();
	  B_LOCATE(40, 29);
	  B_PRINT("\33[37mZ[u܂B");
	  B_CUROFF();
	  WaitForAMoment(2);
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	  B_CUROFF();
	  changed = 0;
	  break;
	}
      cursor(lastCurX, lastCurY);
    }
}
