/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/dedit.c,v $
 * $Author: kawamoto $
 * $Revision: 1.4 $
 * $Date: 1995/05/08 01:03:36 $
 * $Log: dedit.c,v $
 *	Revision 1.4  1995/05/08  01:03:36  kawamoto
 *	Version 2.26b
 *
 *	Revision 1.3  1994/04/23  11:35:44  kawamoto
 *	hLgC
 *
 *	Revision 1.2  1993/10/24  18:33:35  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:39:15  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "edit.h"
#include "dir.h"
#include "diag.h"
#include "undel.h"
#include "diskbios.h"
#include "nonstd.h"
#include "coord.h"
#include "debug.h"
#ifdef __USE_HUPAIRLIB__
#include <process.h>
#endif

#define HUMAN	 1
#define FLOPPY	 2
#define HARD	 3
#define SCSI	 4
#define MEMORY	 5
#define COORDI	 6
#define NONSTD	 7
#define DIAG	 8
#define VISUAL	 9
#define CLEAN	10
#define SECTOR	11
#define FILE	12
#define DIREC	13
#define UNDEL	14
#define COLOR	15
#define QUIT	16

static int menu1(void);
static void floppyMenu(int);
static int menu2(int);
static void humanMenu(int);
static int menu3(int);
static void coordinationMenu(int);
static int menu4(int);
static void fileSelEdit(char *);

provisional Provisional_adjusts;

static void provisional_adjust(char *ptr)
{
  for (; *ptr; ++ptr)
    switch (*ptr)
      {
      case 'f':
      case 'F':
	Provisional_adjusts.function = 1;
	break;
      case 's':
      case 'S':
	Provisional_adjusts.selection = 1;
	break;
      default:
	break;
      }
}

static void
check_TwentyOne (void)
{
  if (GetTwentyOneID () == TWON_ID)
    *(int*) &flag_TwentyOne = GetTwentyOneOptions();
}

static void
check_TwoSCSI (void)
{
  extern int TwoSCSI;		/* edithdsector.c */

  register unsigned int_ reg_d0 __asm ("d0");
  register unsigned int_ reg_d1 __asm ("d1") = 0x1e;

  __asm ("moveq.l #__SCSIDRV,%0\n\t"
	 "trap #15"
	 : "=d" (reg_d0)
	 : "d" (reg_d1));

  TwoSCSI = (reg_d0 == -2);
}

static void
set_user_level (void)
{
  UserLevel = EXPERT_USER;
}

static void
print_version (void)
{
  _dos_print ("dedit version 2.26b patchlevel 2\n");
}

static void
print_usage (void)
{
  print_version ();

  _dos_print (
	"gp@PFdedit [-adjust=<list>] [-timer=<num>] [-macro=<file>]" CRLF
	"\tldmtɂN" CRLF
	"\t-adjust=<list>\tlist ł͎̂̂gݍB" CRLF
	"\t\tf\tfunction key ̔z𑼂̃AvP[VƑB" CRLF
	"\t\ts\tfBNgGfBbgɃt@CIB" CRLF
	"\t\tϐ DEDITADJUST ɃZbĝLB" CRLF
	"\t\t\tset DEDITADJUST=fs" CRLF
	"\t-timer=<num>\tnonstandard track edit ɉăgbÑ^C}[lݒ肷B" CRLF
	"\t\t\tftHg 1000B" CRLF
	"\t-macro=<file>\t}NǂݍݎsB" CRLF
	"gp@QFdedit [-adjust=<list>] [-timer=<num>] [-macro=<file>] XCb`" CRLF
	"\t-H\t\tguman disks" CRLF
	"\t-Hs\t\tsector edit" CRLF
	"\t-Hf\t\tfile edit" CRLF
	"\t-Hd\t\tdirectory edit" CRLF
	"\t-Hu\t\tundel" CRLF
	"\t-f\t\tfloppy disks" CRLF
	"\t-ft\t\tnonstandard track edit" CRLF
	"\t-fr\t\tread diagnostic" CRLF
	"\t-fv\t\tvisual" CRLF
	"\t-fc\t\tcleaning" CRLF
	"\t-h\t\thard disks" CRLF
	"\t-s\t\tSCSI devices" CRLF
	"\t-m\t\tmemories" CRLF
	"\t-c\t\tcoordination" CRLF
	"\t-cc\t\tcolor coordination" CRLF
	"gp@RFdedit [-adjust=<list>] [-macro=<file>] t@CXg" CRLF
	"\tfile edit (ChJ[hgp)" CRLF
  );
}

int
main (int argc, char* argv[])
{
  direntry *wptr;
  int i, j;
extern unsigned short timer_max;

#if 0
#ifdef __USE_HUPAIRLIB__
  SetCoordinationPath(get_traditional_argv0());
#else
  SetCoordinationPath(argv[0]);
#endif
#endif
  check_TwentyOne();
  check_TwoSCSI();
  set_user_level();
  B_CUROFF();
  {
    char *env;

    if ((env = getenv("DEDITADJUST")))
      provisional_adjust(env);
  }
  i = 1;
  while (i < argc)
    {
      if (argv[i][0] != '-')
	{
	  ++i;
	  continue;
	}
      if (strcmp (argv[i], "--version") == 0)
	{
	  print_version ();
	  return 0;
	}
      else if (strcmp (argv[i], "--help") == 0)
	{
	  print_usage ();
	  return 0;
	}

      if (strncmp(argv[i] + 1, "timer=", 6) == 0)
	timer_max = atoi(argv[i] + 7);
      else if (strncmp(argv[i] + 1, "adjust=", 7) == 0)
	provisional_adjust(argv[i] + 5);
      else if (strncmp(argv[i] + 1, "macro=", 6) == 0)
	{
	  if (MacroDef(argv[i] + 7))
	    {
	      PRINT("t@C ");
	      PRINT(argv[i] + 7);
	      PRINT ("݂܂B" CRLF);
	      return 1;
	    }
	}
      else
	{
	  ++i;
	  continue;
	}
      j = i;
      do
	{
	  argv[j] = argv[j + 1];
	}
      while (argv[++j]);
      --argc;
    }
  if ((argc == 2) && (argv[1][0] == '-'))
    {
      switch (argv[1][1])
	{
	case 'H':
	  CurDrive = CURDRV() + 1;
	  if (GetDPB(0))
	    return 0;
	  switch (argv[1][2])
	    {
	    case 0:
	      Pre();
	      humanMenu(1);
	      Post();
	      return 0;
	    case 's':
	      Pre();
	      ClearPath();
	      SectorEdit(0);
	      Post();
	      return 0;
	    case 'f':
	      Pre();
	      ClearPath();
	      while (1)
		{
		  wptr = FileSel();
		  if (wptr == (direntry *)ERROR)
		    break;
		  FileEdit(wptr);
		}
	      Post();
	      return 0;
	    case 'd':
	      Pre();
	      ClearPath();
	      DirecEdit();
	      Post();
	      return 0;
	    case 'u':
	      Pre();
	      ClearPath();
	      while (DeletedSel() != ERROR)
		Undel();
	      Post();
	      return 0;
	    }
	case 'f':
	  switch (argv[1][2])
	    {
	    case 0:
	      Pre();
	      floppyMenu(1);
	      Post();
	      return 0;
	    case 't':
	      Pre();
	      if (NonStdTrackSel())
		NonStdEdit();
	      Post();
	      return 0;
	    case 'r':
	      Pre();
	      if (DiagSel())
		DiagEdit();
	      Post();
	      return 0;
	    case 'v':
	      Pre();
	      if (VisualSel())
		Visual();
	      Post();
	      return 0;
	    case 'c':
	      Pre();
	      if (CleaningSel())
		Cleaning();
	      Post();
	      return 0;
	    }
	case 'h':
	  Pre();
	  HDsectorEdit();
	  Post();
	  return 0;
	case 's':
	  Pre();
	  SCSIblockEdit();
	  Post();
	  return 0;
	case 'm':
	  Pre();
	  MemEdit();
	  Post();
	  return 0;
	case 'c':
	  switch (argv[1][2])
	    {
	    case 0:
	      Pre();
	      coordinationMenu(1);
	      Post();
	      return 0;
	    case 'c':
	      Pre();
	      ColorCoordination();
	      Post();
	      return 0;
	    }
	default:
	  print_usage ();
	  return 1;
	}
    }
  Pre();
  CurDrive = CURDRV() + 1;
  if (argc > 1)
    {
      while (--argc > 0)
	fileSelEdit(*++argv);
      Post();
      return 0;
    }
  while (1)
    {
      switch (menu1())
	{
	case HUMAN:
	  humanMenu(0);
	  break;
	case FLOPPY:
	  floppyMenu(0);
	  break;
	case HARD:
	  HDsectorEdit();
	  break;
	case SCSI:
	  SCSIblockEdit();
	  break;
	case MEMORY:
	  MemEdit();
	  break;
	case COORDI:
	  coordinationMenu(0);
	  break;
	case QUIT:
	  Post();
	  return 0;
	}
    }

  return 0;
}

static int menu1()
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  B_LOCATE(34, 8);
  B_PRINT("\33[36m[[[  \33[35ml`hm@ldmt  \33[36m]]]");
  B_LOCATE(30, 11);
  B_PRINT("\33[37mP    g@");
  B_LOCATE(30, 12);
  B_PRINT("\33[37mQ    @");
  B_LOCATE(30, 13);
  B_PRINT("\33[37mR    @");
  B_LOCATE(30, 14);
  B_PRINT("\33[37mS    rbrh@");
  B_LOCATE(30, 15);
  B_PRINT("\33[37mT    ");
  B_LOCATE(30, 16);
  B_PRINT("\33[37mU    ");
  B_LOCATE(30, 17);
  B_PRINT(MesESCend);
  B_LOCATE(37, 20);
  B_PRINT(MesWhichSelectQ);
  while (1)
    {
      switch (GetKey())
	{
	case 0x01:
	case 0x43:
	case 0x08:
	  CheckShift();
	  return QUIT;
	case 0x4b:
	case 0x02:
	  return HUMAN;
	case 0x4c:
	case 0x03:
	  return FLOPPY;
	case 0x4d:
	case 0x04:
	  return HARD;
	case 0x47:
	case 0x05:
	  return SCSI;
	case 0x48:
	case 0x06:
	  return MEMORY;
	case 0x49:
	case 0x07:
	  return COORDI;
	default:
	  continue;
	}
    }
}

static void floppyMenu(int flag)
{
  while (1)
    {
      switch (menu2(flag))
	{
	case NONSTD:
	  if (NonStdTrackSel())
	    NonStdEdit();
	  continue;
	case DIAG:
	  if (DiagSel())
	    DiagEdit();
	  continue;
	case VISUAL:
	  if (VisualSel())
	    Visual();
	  continue;
	case CLEAN:
	  if (CleaningSel())
	    Cleaning();
	  continue;
	}
      break;
    }
}

static int menu2(int flag)
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  B_LOCATE(32, 8);
  B_PRINT("\33[36m[[[  \33[35m@  \33[36m]]]");
  B_LOCATE(28, 12);
  B_PRINT("\33[37mP    @");
  B_LOCATE(28, 13);
  B_PRINT("\33[37mQ    @");
  B_LOCATE(28, 14);
  B_PRINT("\33[37mR    ");
  B_LOCATE(28, 15);
  B_PRINT("\33[37mS    ");
  B_LOCATE(28, 16);
  B_PRINT(flag ? MesESCend : MesRetMain);
  B_LOCATE(37, 20);
  B_PRINT(MesWhichSelectQ);
  while (1)
    {
      switch (GetKey())
	{
	case 0x01:
	case 0x48:
	case 0x06:
	  CheckShift();
	  return QUIT;
	case 0x4b:
	case 0x02:
	  return NONSTD;
	case 0x4c:
	case 0x03:
	  return DIAG;
	case 0x4d:
	case 0x04:
	  return VISUAL;
	case 0x47:
	case 0x05:
	  return CLEAN;
	default:
	  continue;
	}
    }
}

static void humanMenu(int flag)
{
  direntry *wptr;

  while (GetDPB(1))
    {
      int d;

      B_LOCATE(42, 25);
      B_PRINT(MesDriveNameQ);
      d = GetASC();
      CurDrive = toupper(d) - ('A'-1);
      B_LOCATE(0, 25);
      B_ERA_AL();
      B_CUROFF();
      if (CurDrive < 1 || CurDrive > 26)
	return;
    }
  while (1)
    {
      switch (menu3(flag))
	{
	case SECTOR:
	  ClearPath();
	  SectorEdit(0);
	  continue;
	case FILE:
	  ClearPath();
	  while (1)
	    {
	      wptr = FileSel();
	      if (wptr == (direntry *)ERROR)
		break;
	      FileEdit(wptr);
	    }
	  continue;
	case DIREC:
	  ClearPath();
	  DirecEdit();
	  continue;
	case UNDEL:
	  ClearPath();
	  while (DeletedSel() != ERROR)
	    Undel();
	  continue;
	}
      break;
    }
}

static int menu3(int flag)
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  B_LOCATE(33, 8);
  B_PRINT("\33[36m[[[  \33[35mg@  \33[36m]]]");
  B_LOCATE(31, 12);
  B_PRINT("\33[37mP    ");
  B_LOCATE(31, 13);
  B_PRINT("\33[37mQ    ");
  B_LOCATE(31, 14);
  B_PRINT("\33[37mR    ");
  B_LOCATE(31, 15);
  B_PRINT("\33[37mS    ");
  B_LOCATE(31, 16);
  B_PRINT(flag ? MesESCend : MesRetMain);
  B_LOCATE(37, 20);
  B_PRINT(MesWhichSelectQ);
  while (1)
    {
      switch (GetKey())
	{
	case 0x01:
	case 0x48:
	case 0x06:
	  CheckShift();
	  return QUIT;
	case 0x4b:
	case 0x02:
	  return SECTOR;
	case 0x4c:
	case 0x03:
	  return FILE;
	case 0x4d:
	case 0x04:
	  return DIREC;
	case 0x47:
	case 0x05:
	  return UNDEL;
	default:
	  continue;
	}
    }
}

static void coordinationMenu(int flag)
{
  while (1)
    {
      switch (menu4(flag))
	{
	case COLOR:
	  ColorCoordination();
	  continue;
	}
      break;
    }
}

static int menu4(int flag)
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  B_LOCATE(32, 8);
  B_PRINT("\33[36m[[[  \33[35mb  \33[36m]]]");
  B_LOCATE(31, 12);
  B_PRINT("\33[37mP    ");
  B_LOCATE(31, 13);
  B_PRINT(flag ? MesESCend : MesRetMain);
  B_LOCATE(37, 20);
  B_PRINT(MesWhichSelectQ);
  while (1)
    {
      switch (GetKey())
	{
	case 0x01:
	case 0x4c:
	case 0x03:
	  CheckShift();
	  return QUIT;
	case 0x4b:
	case 0x02:
	  return COLOR;
	default:
	  continue;
	}
    }
}

typedef struct _filbuf_compatible {
  uchar ATR;
  uchar DRIVENO;
  ushort DIRCLS;
  ushort DIRFAT;
  ushort DIRSEC;
  ushort DIRPOS;
  char FILENAME[8];
  char EXT[3];
  uchar atr;
  ushort time;
  ushort date;
  ulong fileLen;
  char fileName[23];
} filbuf_compatible;

static int name_compare(direntry *wptr, filbuf_compatible *bptr)
{
#define CONTINUE 0
#define BREAK 1
  int i;
  char *cptr;

  if (wptr->fileName[0] == 0)
    return CONTINUE;
  cptr = bptr->fileName;
  for (i = 0; i < 8; ++i, ++cptr)
    if (toupper_TwentyOne(wptr->fileName[i]) != toupper_TwentyOne(*cptr))
      break;
  if (i == 8)
    {
      if (flag_TwentyOne.twentyone_option)
	{
	  for (i = 0; i < 10; ++i, ++cptr)
	    {
	      if (toupper_TwentyOne(wptr->fileName2[i]) != toupper_TwentyOne(*cptr))
		break;
	      if (*cptr == 0)
		break;
	    }
	  if ((i < 10) && (wptr->fileName2[i]))
	    return CONTINUE;
	}
      while (*cptr && (*cptr != '.'))
	++cptr;
    }
  else
    {
      if (wptr->fileName[i] != ' ')
	return CONTINUE;
      if (*cptr && (*cptr != '.'))
	return CONTINUE;
    }
  if (*cptr == '.')
    ++cptr;
  for (i = 0; i < 3; ++i, ++cptr)
    if (toupper_TwentyOne(wptr->ext[i]) != toupper_TwentyOne(*cptr))
      break;
  if ((i < 3) && (wptr->ext[i] != ' '))
    return CONTINUE;
  if (*cptr)
    return CONTINUE;
  return BREAK;
}

static void fileSelEdit(char *file)
{
  int i;
  direntry *dirptr, *wptr;
  filbuf_compatible buf;
  char file_buf[256];
  struct NAMECKBUF nameckBuf;

  DPRINT("file name %s\n", file);
  strcpy(file_buf, file);
  Assigned_path(file_buf, 1);
  DPRINT("assigned file name %s\n", file_buf);
  NAMECK(file_buf, &nameckBuf);
  i = nameckBuf.drive[0] - 'A' + 1;
  if (GETDPB(i, &DPBbuf) < 0)
    return;
  DGETCHAR();
  DPRINT("max FAT %X\n", DPBbuf.maxfat);
  Is2Bytes = (DPBbuf.maxfat > 0xff8) ? 1 : 0;
  CurDrive = i;
  if (files(0, (struct _filbuf *)&buf, file_buf, 0x3f))
    return;
  dirptr = (direntry *)Malloc(1024);
  PRINT (CRLF);
  do
    {
      if (buf.fileName[0] == '.')
	continue;
      SetPath(nameckBuf.drive, buf.fileName);
      if (diskred(0, (uchar *)dirptr, CurDrive,
		  (VERNUM() >= 0x36380200) ? buf.DIRFAT : buf.DIRSEC, 1))
	return;
      if (buf.DIRPOS == 0xffff)
	{
	  for (wptr = dirptr; wptr < dirptr + 32; ++wptr)
	    if (name_compare(wptr, &buf))
	      break;
	  if (wptr == dirptr + 32)
	    return;
	}
      else
	{
	  wptr = (VERNUM() >= 0x36380200) ?
	  (direntry *)((char *)dirptr + buf.DIRPOS) :
	  dirptr + buf.DIRPOS;
	}
      FileEdit(wptr);
    }
  while (!nfiles(0, (struct _filbuf *)&buf));
  free(dirptr);
}
