/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/dirsub.c,v $
 * $Author: kawamoto $
 * $Revision: 1.4 $
 * $Date: 1995/05/08 01:03:46 $
 * $Log: dirsub.c,v $
 *	Revision 1.4  1995/05/08  01:03:46  kawamoto
 *	Version 2.26b
 *
 *	Revision 1.3  1994/04/23  11:36:05  kawamoto
 *	hLgC
 *
 *	Revision 1.2  1993/10/24  18:34:59  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:40:31  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "dir.h"
#include "debug.h"

#define LOCATE_BASE	11

TwonFlags flag_TwentyOne;

int toupper_TwentyOne(int c)
{
  return (flag_TwentyOne.case_option) ? c : toupper(c);
}

int pathcmp_TwentyOne(char *ptr1, char *ptr2)
{
  unsigned char c1, c2;

  while (1)
    {
      c1 = toupper_TwentyOne(*ptr1++);
      c2 = toupper_TwentyOne(*ptr2++);
      if (c1 == 0)
	return 0;
      if (c1 == '/')
	c1 = '\\';
      if (c2 == '/')
	c2 = '\\';
      if (c1 != c2)
	return c1 - c2;
    }
}

char henkouDir;

int checkHenkouDir(int type)
{
  int i = 0;
  char *p = NULL;

  if (henkouDir == 0)
    return 0;
  switch (type)
    {
    case HenEND:
      i = LOCATE_BASE+7;
      break;
    case HenDRIVE:
      i = LOCATE_BASE+2;
      break;
    case HenDIR:
      i = LOCATE_BASE;
      break;
    case HenREAD:
      i = LOCATE_BASE+6;
      break;
    }
  B_LOCATE(i, 29);
  B_PRINT("\33[36mfBNgL܂B{");
  switch (type)
    {
    case HenEND:
      p = "I";
      break;
    case HenDRIVE:
      p = "hCuύX";
      break;
    case HenDIR:
      p = "fBNgړ";
      break;
    case HenREAD:
      p = "ǂݍ";
      break;
    }
  B_PRINT(p);
  B_PRINT("܂iy/njH ");
  i = GetKey();
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (i == 0x16)
    {
      henkouDir = 0;
      return 0;
    }
  else
    return 1;
}

void funcREAD()
{
  int lCurY, lLocY;
  uchar *lAdrDir;
  uchar dummy[1024];

  if (checkHenkouDir(HenREAD))
    return;
  if (diskred(0, dummy, CurDrive, FATnoToSector(fatNo), 1))
    return;
  lAdrDir = adrDir;
  lCurY = curY;
  lLocY = locY;
  readDirec(0);
  adrDir = lAdrDir;
  curY = lCurY;
  locY = lLocY;
  if (markFlag)
    funcSWAPsub();
  dDump();
}

void funcWRITE()
{
  int d;
  uchar *lAdrDir;
  uchar dummy[1024];

  B_LOCATE(22, 29);
  B_PRINT(MesWriteOKQ);
  d = GetKey();
  B_LOCATE(0, 29);
  B_ERA_AL();
  if (diskred(0, dummy, CurDrive, FATnoToSector(fatNo), 1))
    return;
  if (d == 0x16)
    {
      henkouDir = 0;
      if (lower)
	{ 
	  lAdrDir = (lower > 0) ? (topDir + ((lower - 1) << 5)) : (endDir + 608);
	  for ( ; *lAdrDir == 0xe5; lAdrDir -= 32)
	    for (d = 0; d < 32; ++d)
	      lAdrDir[d] = 0;
	}
      writeDirec();
      if (markFlag)
	funcSWAPsub();
      dDump();
    }
}

int toCHILD()
{
  int d;
  uchar dummy[1024];

  if (lower == 0)
    return 1;
  d = ((adrDir - dirPtr) >> 5) + curY;
  if (!killedSelect && (dirPtr[d << 5] == 0xe5))
    return 1;
  if (!(dirPtr[(d << 5) + 11] & 16))
    return 0;
  if (checkHenkouDir(HenDIR))
    return 1;
  if (diskred(0, dummy, CurDrive, FATnoToSector(fatNo), 1))
    return 1;
  if (markFlag)
    {
      funcSWAPsub();
      dDump();
    }
  fatNo = ToChild((direntry *)dirPtr + d, d, 0);
  readDirec(1);
  adrDir = topDir;
  curY = 0;
  locY = curY + 6;
  dDump();
  B_LOCATE(0, 4);
  B_COLOR(3);
  PrintPath();
  B_CUROFF();
  return 1;
}

int toPAREN()
{
  int offset;
  direntry *wPtr;
  uchar dummy[1024];

  if (diskred(0, dummy, CurDrive, FATnoToSector(fatNo), 1))
    return 1;
  if (markFlag)
    {
      funcSWAPsub();
      dDump();
    }
  if ((fatNo = ToParent(&offset)) == ERROR)
    {
      fatNo = 0;
      return 0;
    }
  readDirec(1);
  wPtr = (direntry *)dirPtr + offset;
  adrDir = (uchar *)wPtr - 320;
  if (adrDir < topDir)
    adrDir = topDir;
  if (adrDir > endDir)
    adrDir = endDir;
  curY = wPtr - (direntry *)adrDir;
  locY = curY + 6;
  dDump();
  B_LOCATE(0, 4);
  B_COLOR(3);
  PrintPath();
  B_CUROFF();
  return 1;
}

void funcDRIVE()
{
  int d, offset = 0, ret;
  direntry *wPtr;
  uchar dummy[1024];

  if (checkHenkouDir(HenDRIVE))
    return;
  B_LOCATE(42, 29);
  B_PRINT(MesDriveNameQ);
  d = GetASC();
  d = toupper(d) - ('A'-1);
  B_LOCATE(0, 29);
  B_ERA_AL();
  B_CUROFF();
  if (d < 1 || d > 26)
    return;
  if ((ret = diskred(0, dummy, d, 0, 1)) != 0)
    return;
  if (GETDPB(d, &DPBbuf) >= 0)
    {
      DPRINT("max FAT %X\n", DPBbuf.maxfat);
      Is2Bytes = (DPBbuf.maxfat > 0xff8) ? 1 : 0;
      CurDrive = d;
      ClearPath();
      fatNo = ToParent(&d);
      sizeDir = DPBbuf.fatlen;
      free(fatPtr);
      fatPtr = Malloc(sizeDir << 10);
      if (diskred(0, fatPtr, CurDrive, DPBbuf.fatsec, sizeDir))
	{
	  Post();
	  exit(0);
	}
      if (fatNo == ERROR)
	offset = jumpToCurPath();
      readDirec(1);
      henkouDir = 0;
      wPtr = (direntry *)dirPtr + offset;
      adrDir = (uchar *)wPtr - 320;
      if (adrDir < topDir)
	adrDir = topDir;
      if (adrDir > endDir)
	adrDir = endDir;
      curY = wPtr - (direntry *)adrDir;
      locY = curY + 6;
      if (markFlag)
	funcSWAPsub();
      dDump();
      B_LOCATE(0, 4);
      B_COLOR(3);
      PrintPath();
      B_CUROFF();
    }
}

void funcTOP()
{
  if (lower == 0)
    return;
  if (markFlag)
    {
      funcSWAPsub();
      dDump();
      return;
    }
  FNCKEYST(Provisional_adjusts.function ? 6 : 4, " ͈͎~");
  FNCKEYST(Provisional_adjusts.function ? 7 : 5, " ͈͏I");
  markTop = markEnd = adrDir + (curY << 5);
  markFlag = 1;
  rev(curY, curY);
}

void funcSWAP()
{
  uchar *mark2top, *mark2end;
  uchar *work;
  int length, length2;

  if (lower == 0)
    return;
  if (markFlag == 0)
    {
      B_LOCATE(35, 29);
      B_PRINT("\33[36m͈͂w肳Ă܂B");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      return;
    }
  if (markFlag == 1)
    {
      FNCKEYST(Provisional_adjusts.function ? 7 : 5, MesFKeySort);
      markFlag = 2;
      underon();
      return;
    }
  mark2top = adrDir + ((curY + 1) << 5);
  if (mark2top >= markTop && mark2top <= (markEnd + 32))
    return;
  henkouDir = 1;
  if (mark2top < markTop)
    {
      mark2end = markEnd;
      markEnd = markTop - 32;
      work = markTop;
      markTop = mark2top;
      mark2top = work;
    }
  else
    {
      mark2end = mark2top - 32;
      mark2top = markEnd + 32;
    }
  length = markEnd - markTop + 32;
  length2 = mark2end - mark2top + 32;
  work = Malloc(length);
  movmem((char *)markTop, (char *)work, length);
  movmem((char *)mark2top, (char *)markTop, length2);
  movmem((char *)work, (char *)markTop + length2, length);
  free(work);
  funcSWAPsub();
  dDump();
}

void funcSWAPsub()
{
  FNCKEYST(Provisional_adjusts.function ? 6 : 4, MesFKeyRange);
  FNCKEYST(Provisional_adjusts.function ? 7 : 5, MesFKeySort);
  if (markFlag == 2)
    {
      underoff();
      if (curY == -1)
	{
	  curY = 0;
	  locY = 6;
	}
    }
  markFlag = 0;
  markTop = markEnd = (uchar *)-1;
}

void underon()
{
  uchar *wPtr;

  wPtr = (uchar *)0xe03711 + (curY << 11);
#ifdef MOUSE
  MS_CUROF();
#endif
  B_CUROFF();
  B_BPOKE(wPtr, 0xff);
  B_BPOKE(wPtr + 0x080, 0xff);
  B_BPOKE(wPtr + 0x100, 0xff);
  B_BPOKE(wPtr + 0x180, 0xff);
  B_BPOKE(wPtr + 0x20000, 0xff);
  B_BPOKE(wPtr + 0x20080, 0xff);
  B_BPOKE(wPtr + 0x20100, 0xff);
  B_BPOKE(wPtr + 0x20180, 0xff);
  lCurY = curY;
#ifdef MOUSE
  MS_CURON();
#endif
}

void underoff()
{
  uchar *wPtr;

  wPtr = (uchar *)0xe03711 + (lCurY << 11);
#ifdef MOUSE
  MS_CUROF();
#endif
  B_CUROFF();
  B_BPOKE(wPtr, 0);
  B_BPOKE(wPtr + 0x080, 0);
  B_BPOKE(wPtr + 0x100, 0);
  B_BPOKE(wPtr + 0x180, 0);
  B_BPOKE(wPtr + 0x20000, 0);
  B_BPOKE(wPtr + 0x20080, 0);
  B_BPOKE(wPtr + 0x20100, 0);
  B_BPOKE(wPtr + 0x20180, 0);
#ifdef MOUSE
  MS_CURON();
#endif
}

void funcRENAME()
{
  char inBuf[24], dirBuf[32];
  int i, flag, atr, max;
  char *ptr1, *ptr2;

  if (adrDir[curY << 5] == 0xe5)
    return;
  ptr1 = (char *)&adrDir[curY << 5];
  dirBuf[11] = ptr1[11];
  ptr2 = inBuf;
  for (i = 0; i < 8 && (*ptr1 != ' '); ++i)
    *ptr2++ = *ptr1++;
  if (i == 8)
    {
      ptr1 = (char *)&adrDir[curY << 5] + 12;
      for (i = 0; i < 10 && *ptr1; ++i)
	*ptr2++ = *ptr1++;
    }
  ptr1 = (char *)&adrDir[curY << 5] + 8;
  if (*ptr1 != ' ')
    {
      *ptr2++ = '.';
      for (i = 0; i < 3 && (*ptr1 != ' '); ++i)
	*ptr2++ = *ptr1++;
    }
  *ptr2 = 0;
  if (inBuf[0] == 0x05)
    inBuf[0] = (char)0xe5;
  B_LOCATE(29, 29);
  B_PRINT("\33[37mVO H ");
  C_LOCATE(43, 29);
  i = GetName(inBuf, 0, 0);
  B_LOCATE(0, 29);
  B_ERA_AL();
  if (i == ERROR)
    return;
  if (inBuf[0] == (char)0xe5)
    inBuf[0] = 0x05;
  ptr1 = inBuf;
  ptr2 = dirBuf;
  for (i = 0; i < 8; ++i)
    {
      if (*ptr1 == '.' || *ptr1 == 0)
	break;
      *ptr2++ = *ptr1++;
    }
  for ( ; i < 8; ++i)
    *ptr2++ = ' ';
  ptr2 = dirBuf + 12;
  for (i = 0; i < 10; ++i)
    {
      if (*ptr1 == '.' || *ptr1 == 0)
	break;
      *ptr2++ = *ptr1++;
    }
  for ( ; i < 10; ++i)
    *ptr2++ = 0;
  if (*ptr1 == '.')
    ++ptr1;
  ptr2 = dirBuf + 8;
  for (i = 0; i < 3; ++i)
    {
      if (*ptr1 == 0)
	break;
      *ptr2++ = *ptr1++;
    }
  for ( ; i < 3; ++i)
    *ptr2++ = ' ';
  flag = 1;
  for (ptr1 = (char *)topDir; *ptr1; ptr1 += 32)
    {
      if (*ptr1 == (char)0xe5 || ptr1 == (char *)&adrDir[curY << 5])
	continue;
      ptr2 = dirBuf;
      flag = 0;
      atr = ptr1[11] & ptr2[11];
      max = (flag_TwentyOne.twentyone_option) ? 22 : 11;
      for (i = 0; i < max; ++i)
	{
	  if (i == 11)
	    continue;
	  if (toupper_TwentyOne(ptr1[i]) != toupper_TwentyOne(ptr2[i]))
	    {
	      flag = 1;
	      break;
	    }
	}
      if (!flag)
	break;
    }
  if (!flag)
    {
      B_LOCATE(37, 29);
      B_PRINT("\33[36mOdĂ܂B");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      return;
    }
  henkouDir = 1;
  ptr1 = dirBuf;
  ptr2 = (char *)&adrDir[curY << 5];
  for (i = 0; i < 11; ++i)
    ptr2[i] = ptr1[i];
  for (i = 12; i < 22; ++i)
    ptr2[i] = ptr1[i];
  dDump2(curY);
}

static int lastDate = 1980 << 16, lastTime = 0;

void funcRETIME()
{
  int i;
  uchar *ptr, works[4];
  char inBuf[11];
  union DIV {
    int tot;
    ushort word[2];
    uchar byte[4];
  } date, time;

date_in:
  B_LOCATE(40, 29);
  B_PRINT("\33[37mVt H ");
  C_LOCATE(54, 29);
  inBuf[0] = '1';
  inBuf[1] = '9';
  i = GetDateTime(inBuf + 2, '-');
  B_LOCATE(0, 29);
  B_ERA_AL();
  if (i) 
    return;
  if (inBuf[2] == '\0')
    {
      while (1)
	{
	  B_LOCATE(10, 29);
	  B_PRINT("\33[36m[\33[37mC\33[36m]\33[35m  ݂̓t@\33[36m[\33[37mL\33[36m]\33[35m  ȑO̓͒l@\33[36m[\33[37mN\33[36m]\33[35m  ύXȂ@\33[36m[\33[37mS\33[36m]\33[35m  \33[37m");
	  C_LOCATE(81, 29);
	  i = GetCon();
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	  switch (i)
	    {
	    case 0x11b /* ESC */:
	      goto date_in;
	    case 'c':
	    case 'l':
	    case 'n':
	    case 's':
	      inBuf[2] = toupper(i);
	      break;
	    case 'C':
	    case 'L':
	    case 'N':
	    case 'S':
	      inBuf[2] = i;
	      break;
	    default:
	      continue;
	    }
	  break;
	}
    }
  switch (inBuf[2])
    {
    case 'C':
      date.tot = BINDATEGET();
      date.tot = DATEBIN(date.tot);
      break;
    case 'L':
      date.tot = lastDate;
      break;
    case 'N':
      date.tot = -1;
      break;
    case 'S':
      date.tot = 1980 << 16;
      break;
    default:
      if ((date.tot = DATECNV(inBuf)) == -1)
	{
	  B_PUTC(7);
	  goto date_in;
	}
      break;
    }
  works[2] = (date.byte[2] << 5) + date.byte[3];
  works[3] = (date.word[0] & 0x0fff) - 1980;
  works[3] <<= 1;
  works[3] += date.byte[2] >> 3;
time_in:
  B_LOCATE(40, 29);
  B_PRINT("\33[37mV H ");
  C_LOCATE(54, 29);
  i = GetDateTime(inBuf, ':');
  B_LOCATE(0, 29);
  B_ERA_AL();
  if (i)
    goto date_in;
  if (inBuf[0] == '\0')
    {
      while (1)
	{
	  B_LOCATE(10, 29);
	  B_PRINT("\33[36m[\33[37mC\33[36m]\33[35m  ݂̎@\33[36m[\33[37mL\33[36m]\33[35m  ȑO̓͒l@\33[36m[\33[37mN\33[36m]\33[35m  ύXȂ@\33[36m[\33[37mS\33[36m]\33[35m  \33[37m");
	  C_LOCATE(81, 29);
	  i = GetCon();
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	  switch (i)
	    {
	    case 0x11b /* ESC */:
	      goto time_in;
	    case 'c':
	    case 'l':
	    case 'n':
	    case 's':
	      inBuf[0] = toupper(i);
	      break;
	    case 'C':
	    case 'L':
	    case 'N':
	    case 'S':
	      inBuf[0] = i;
	      break;
	    default:
	      continue;
	    }
	  break;
	}
    }
  switch (inBuf[0])
    {
    case 'C':
      time.tot = TIMEGET();
      time.tot = TIMEBIN(time.tot);
      break;
    case 'L':
      time.tot = lastTime;
      break;
    case 'N':
      time.tot = -1;
      break;
    case 'S':
      time.tot = 0;
      break;
    default:
      if ((time.tot = TIMECNV(inBuf)) == -1)
	{
	  B_PUTC(7);
	  goto time_in;
	}
      break;
    }
  works[0] = (time.byte[2] << 5) + (time.byte[3] >> 1);
  works[1] = (time.byte[1] << 3) + (time.byte[2] >> 3);
/* set_all */
  henkouDir = 1;
  if (time.tot != -1)
    lastTime = time.tot;
  if (date.tot != -1)
    lastDate = date.tot;
  if (markFlag)
    {
      if (time.tot != -1)
	for (ptr = markTop; ptr <= markEnd; ptr += 32)
	  {
	    ptr[22] = works[0];
	    ptr[23] = works[1];
	  }
      if (date.tot != -1)
	for (ptr = markTop; ptr <= markEnd; ptr += 32)
	  {
	    ptr[24] = works[2];
	    ptr[25] = works[3];
	  }
      dDump();
    }
  else
    {
      ptr = &adrDir[curY << 5];
      if (time.tot != -1)
	{
	  ptr[22] = works[0];
	  ptr[23] = works[1];
	}
      if (date.tot != -1)
	{
	  ptr[24] = works[2];
	  ptr[25] = works[3];
	}
      dDump2(curY);
    }
}

void funcX()
{
  direntry *ptr;

  henkouDir = 1;
  if (markFlag)
    {
      for (ptr = (direntry *)markTop; ptr <= (direntry *)markEnd; ++ptr)
	if ((ptr->atr & 0x48) == 0)
	  ptr->atr ^= 0x80;
      dDump();
    }
  else
    {
      if (adrDir[(curY << 5) + 11] & 0x48)
	return;
      adrDir[(curY << 5) + 11] ^= 0x80;
      dDump2(curY);
    }
}

void funcS()
{
  direntry *ptr;

  henkouDir = 1;
  if (markFlag)
    {
      for (ptr = (direntry *)markTop; ptr <= (direntry *)markEnd; ++ptr)
	if ((ptr->atr & 0x18) == 0)
	  ptr->atr ^= 4;
      dDump();
    }
  else
    {
      if (adrDir[(curY << 5) + 11] & 0x18)
	return;
      adrDir[(curY << 5) + 11] ^= 4;
      dDump2(curY);
    }
}

void funcH()
{
  direntry *ptr;

  henkouDir = 1;
  if (markFlag)
    {
      for (ptr = (direntry *)markTop; ptr <= (direntry *)markEnd; ++ptr)
	ptr->atr ^= 2;
      dDump();
    }
  else
    {
      adrDir[(curY << 5) + 11] ^= 2;
      dDump2(curY);
    }
}

void funcR()
{
  direntry *ptr;

  henkouDir = 1;
  if (markFlag)
    {
      for (ptr = (direntry *)markTop; ptr <= (direntry *)markEnd; ++ptr)
	ptr->atr ^= 1;
      dDump();
    }
  else
    {
      adrDir[(curY << 5) + 11] ^= 1;
      dDump2(curY);
    }
}

static void rwDirec(int, int (*)(int, uchar *, int, int, int));

void readDirec(int sw)
{
  rwDirec(sw, diskred);
}

void writeDirec()
{
  rwDirec(0, diskwrt);
}

static void rwDirec(int sw, int (*rw)(int, uchar *, int, int, int))
{
  int fatWork;
  uchar *wPtr;

  if (fatNo == 0)
    {
      sizeDir = DPBbuf.dircount / (DPBbuf.byte >> 5);
      fatWork = DPBbuf.dirsec;
      if (sw)
	{
	  free(dirPtr);
	  dirPtr = Malloc(DPBbuf.dircount << 5);
	}
      if ((*rw)(0, dirPtr, CurDrive, fatWork, DPBbuf.dircount >> 5))
	{
	  Post();
	  exit(0);
	}
      topDir = dirPtr;
    }
  else
    {
      sizeDir = 0;
      fatWork = fatNo;
      while (FATnoOk(fatPtr, fatWork))
	{
	  ++sizeDir;
	  fatWork = NextFATNo(fatPtr, fatWork);
	}
      if (sw)
	{
	  free(dirPtr);
	  dirPtr = Malloc(sizeDir * (DPBbuf.byte << DPBbuf.shift));
	}
      fatWork = fatNo;
      wPtr = dirPtr;
      while (FATnoOk(fatPtr, fatWork))
	{
	  if ((*rw)(0, wPtr, CurDrive, FATnoToSector(fatWork), DPBbuf.sec + 1))
	    {
	      Post();
	      exit(0);
	    }
	  wPtr += DPBbuf.byte << DPBbuf.shift;
	  fatWork = NextFATNo(fatPtr, fatWork);
	}
      topDir = dirPtr + 64;
    }
  sizeDir *= DPBbuf.byte << DPBbuf.shift;
  for (adrDir = topDir; adrDir < dirPtr + sizeDir; adrDir += 32)
    if (*(char *)adrDir == 0)
      break;
  sizeDir = adrDir - topDir;
  if (sizeDir < 640)
    {
      lower = sizeDir >> 5;
      sizeDir = 640;
    }
  else
    lower = -1;
  endDir = topDir + sizeDir - 640;
  adrDir = topDir;
  curY = 0;
  locX = 17;
  locY = 6;
  if (rw == diskred)
    return;
/*
  B_LOCATE(0, 4);
  B_COLOR(3);
  PrintPath();
  B_CUROFF();
*/
}

void dDump()
{
  int locX, locY;
  uchar *wAdrDir;

  wAdrDir = adrDir;
  locX = 17;
  for (locY = 6; locY < 26; ++ locY)
    {
      convert(wAdrDir, temp);
      Print(locX, locY, temp);
      if (temp[0] == '?')
	rev(locY - 6, locY - 6);
      if (*wAdrDir)
	wAdrDir += 32;
    }
  wAdrDir -= 32;
  if (adrDir <= markEnd && wAdrDir >= markTop)
    {
      locX = (adrDir > markTop) ? 0 : markTop - adrDir;
      locY = (wAdrDir > markEnd) ? markEnd - adrDir : wAdrDir - adrDir;
      rev(locX >> 5, locY >> 5);
    }
}

void dDump2(int offset)
{
  int locX, locY;
  uchar *wAdrDir;

  wAdrDir = adrDir;
  if (offset < 0 || offset > 19)
    return;
  locX = 17;
  locY = 6 + offset;
  wAdrDir += offset << 5;
  convert(wAdrDir, temp);
  Print(locX, locY, temp);
  if (temp[0] == '?')
    rev(offset, offset);
  if (wAdrDir <= markEnd && wAdrDir >= markTop)
    {
      locY = (wAdrDir - adrDir) >> 5;
      rev(locY, locY);
    }
}

void rev(int from, int to)
{
  struct TREVPTR txRev;

  txRev.vram_page = 3;
  txRev.x = 136;
  txRev.y = (from << 4) + 96;
  txRev.x1 = 176;
  txRev.y1 = ((to - from) << 4) + 16;
#ifdef MOUSE
  MS_CUROF();
#endif
  TXREV(&txRev);
#ifdef MOUSE
  MS_CURON();
#endif
}

int first_time;

void dirPre()
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  Window(17, 6, 62, 20);
  B_LOCATE(22, 27);
  B_PRINT(MesCursScrl);
  B_PRINT(MesCursUD);
  B_COLOR(3);
  B_CUROFF();
  fatPtr = Malloc(DPBbuf.fatlen * DPBbuf.byte);
  dirPtr = Malloc(1);
  first_time = 1;
}

void dirPost()
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  Clear23();
  NulFuncKey();
  free(fatPtr);
  free(dirPtr);
}

void convert(uchar *from, uchar *to)
{
  uchar *ptr;
  int i, c;

  c = *from;
  if (c == 0)
    {
      for (i = 0; i < 62; i++)
	*to++ = ' ';
      *to = '\0';
      return;
    }
  if (!killedSelect && (c == 0xe5))
    {
      for (i = 0; i < 23; i++)
	*to++ = ' ';
      *to++ = '[';
      *to++ = ' ';
      *to++ = 'k';
      *to++ = 'i';
      *to++ = 'l';
      *to++ = 'l';
      *to++ = 'e';
      *to++ = 'd';
      *to++ = ' ';
      *to++ = ']';
      for (i = 0; i < 29; i++)
	*to++ = ' ';
      *to = '\0';
      return;
    }
  ptr = from;
  if (c == 0x05)
    {
      *to++ = 0xe5;
      ptr++;
      i = 1;
    }
  else if (c == 0xe5)
    {
      *to++ = '?';
      ptr++;
      i = 1;
    }
  else
    i = 0;
  if (flag_TwentyOne.multi_period_option)
    {
      for ( ; (i < 8) && (*ptr != ' '); ++i)
	*to++ = *ptr++;
      c = 8 - i;
      ptr = from + 12;
      for (i = 0; (i < 10) && *ptr && (*ptr != ' '); ++i)
	*to++ = *ptr++;
      c += 10 - i;
      ptr = from + 8;
      if (*ptr == ' ')
	c += 4;
      else
	{
	  *to++ = '.';
	  for (i = 0; (i < 3) && (*ptr != ' '); ++i)
	    *to++ = *ptr++;
	  c += 3 - i;
	}
      while (c-- > 0)
	*to++ = ' ';
    }
  else
    {
      for ( ; i < 8; ++i)
	*to++ = *ptr++;
      ptr = from + 12;
      for (i = 0; i < 10 && *ptr; ++i)
	*to++ = *ptr++;
      for ( ; i < 10; ++i)
	*to++ = ' ';
      ptr = from + 8;
      *to++ = (*ptr == ' ') ? ' ' : '.';
      for (i = 0; i < 3; ++i)
	*to++ = *ptr++;
    }
  *to++ = ' ';
  *to++ = ' ';
  c = from[11];
  *to++ = (c & 128) ? 'X' : '-';
  *to++ = (c & 64) ? 'L' : '-';
  *to++ = (c & 32) ? 'A' : '-';
  *to++ = (c & 16) ? 'D' : '-';
  *to++ = (c & 8) ? 'V' : '-';
  *to++ = (c & 4) ? 'S' : '-';
  *to++ = (c & 2) ? 'H' : '-';
  *to++ = (c & 1) ? 'R' : '-';
  c = from[31];
  c <<= 8;
  c += from[30];
  c <<= 8;
  c += from[29];
  c <<= 8;
  c += from[28];
  *to++ = ' ';
  ptr = to + 8;
  if (from[11] & 32)
    {
      *ptr-- = '0' + (c % 10);
      c /= 10;
      while ((to < ptr) && c)
	{
	  *ptr-- = '0' + (c % 10);
	  c /= 10;
	}
    }
  while (to <= ptr)
    *ptr-- = ' ';
  to += 9;
  *to++ = ' ';
  *to++ = ' ';
  c = ((from[25] >> 1) + 80) % 100;
  *to++ = '0' + (c / 10);
  *to++ = '0' + (c % 10);
  *to++ = '-';
  c = ((from[25] & 1) << 3) + (from[24] >> 5);
  *to++ = '0' + (c / 10);
  *to++ = '0' + (c % 10);
  *to++ = '-';
  c = (from[24] & 31);
  *to++ = '0' + (c / 10);
  *to++ = '0' + (c % 10);
  *to++ = ' ';
  *to++ = ' ';
  c = from[23] >> 3;
  *to++ = '0' + (c / 10);
  *to++ = '0' + (c % 10);
  *to++ = ':';
  c = ((from[23] & 7) << 3) + (from[22] >> 5);
  *to++ = '0' + (c / 10);
  *to++ = '0' + (c % 10);
  *to++ = ':';
  c = (from[22] & 31) << 1;
  *to++ = '0' + (c / 10);
  *to++ = '0' + (c % 10);
  *to = '\0';
}

int jumpToCurPath()
{
  int i, d, offset;
  char pathName[256], fileName[8], ext[3], fileName2[10], *ptr;
  direntry *wTopDir, *wEndDir;

  fatNo = 0;
  offset = 0;
  pathName[0] = CurDrive - 1 + 'A';
  pathName[1] = ':';
  pathName[2] = '\\';
  CURDIR(CurDrive, pathName + 3);
  Assigned_path(pathName, first_time);
  first_time = 0;
  i = pathName[0] - 'A' + 1;
  if (GETDPB(i, &DPBbuf) < 0)
    return 0;
  DPRINT("max FAT %X\n", DPBbuf.maxfat);
  Is2Bytes = (DPBbuf.maxfat > 0xff8) ? 1 : 0;
  CurDrive = i;
  ClearPath();
  sizeDir = DPBbuf.fatlen;
  free(fatPtr);
  fatPtr = Malloc(sizeDir << 10);
  if (diskred(0, fatPtr, CurDrive, DPBbuf.fatsec, sizeDir))
    {
      Post();
      exit(0);
    }
  ptr = pathName + 3;
  while (*ptr)
    {
      for (i = 0; i < 8; ++i)
	{
	  if ((*ptr == '\0') || (*ptr == '\\') || (*ptr == '.'))
	    break;
	  fileName[i] = toupper_TwentyOne(*ptr++);
	}
      for ( ; i < 8; ++i)
	fileName[i] = ' ';
      for (i = 0; i < 10; ++i)
	{
	  if ((*ptr == '\0') || (*ptr == '\\') || (*ptr == '.'))
	    break;
	  fileName2[i] = toupper_TwentyOne(*ptr++);
	}
      for ( ; i < 10; ++i)
	fileName2[i] = '\0';
      while (*ptr && (*ptr != '\\') && (*ptr != '.'))
	++ptr;
      if (*ptr == '.')
	++ptr;
      for (i = 0; i < 3; ++i)
	{
	  if ((*ptr == '\0') || (*ptr == '\\'))
	    break;
	  ext[i] = toupper_TwentyOne(*ptr++);
	}
      for ( ; i < 3; ++i)
	ext[i] = ' ';
      if (*ptr == '\\')
	++ptr;
      readDirec(1);
      wTopDir = (direntry *)topDir;
      wEndDir = (direntry *)(endDir + 640);
      for (d = 0; (wTopDir + d < wEndDir) && (wTopDir[d].fileName[0]); ++d)
	{
	  for (i = 0; i < 8; ++i)
	    if (toupper_TwentyOne(wTopDir[d].fileName[i])
		!= fileName[i])
	      goto next;
	  for (i = 0; i < 3; ++i)
	    if (toupper_TwentyOne(wTopDir[d].ext[i])
		!= ext[i])
	      goto next;
	  for (i = 0; i < 10; ++i)
	    if (toupper_TwentyOne(wTopDir[d].fileName2[i])
		!= fileName2[i])
	      goto next;
	  break;
	next:
	  continue;
	}
      if ((wTopDir + d == wEndDir) || (wTopDir[d].fileName[0] == 0))
	break;
      fatNo = ToChild(wTopDir + d, d + offset, 0);
      offset = 2;
    }
  return offset;
}
