/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/rearch.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:37:46 $
 * $Log: rearch.c,v $
 *	Revision 1.2  1993/10/24  18:37:46  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:43:11  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "search.h"

extern volatile char BusErrorDetected;

static bool comp(uchar *target, uchar *end, uchar *top);

static inline int RPeekC(unsigned char *ptr)
{
register int trap asm("d0");

  BusErrorDetected = 0;
  __asm ("RPeekC_from::\n\t"
	 "moveq #0,%0\n\t"
	 "move.b %1,%0\n"
	 "RPeekC_resume::" : "=d" (trap) : "m" (*ptr));
  if (BusErrorDetected)
    trap = 0x100;
  return trap;
}

static inline int back_comp(srchbuf *bptr)
{
  int num;
  uchar *ground;
  skip *skips;

  ground = bptr->buf_cur;
  skips = bptr->sk_top;
  while (skips <= bptr->sk_end)
    {
      if ((num = (*skips)[RPeekC(ground)]))
	return num;
      ground++;
      skips++;
    }
  return 0;
}

static inline bool back_rearch(srchbuf *bptr)
{
  int num;

  while (bptr->buf_cur >= bptr->buf_top)
    {
      if ((num = back_comp(bptr)) == 0)
	return true;
      bptr->buf_cur -= num;
    }
  return false;
}

static inline bool bound_rearch_pre(srchbuf *bptr)
{
  int offset;
  uchar *ptr;

  offset = bptr->buf_cur - bptr->buf_top + 1;
  bptr->buf_cur = bptr->buf_end + offset;
  bptr->tar_cur = bptr->tar_top - offset;
  for (ptr = bptr->buf_top + bptr->tar_size + offset - 2; ptr >= bptr->buf_top; ptr--)
    {
      if (comp(bptr->tar_end, ptr, bptr->buf_top))
	return true;
      bptr->buf_cur--;
      bptr->tar_cur++;
    }
  return false;
}

static inline bool bound_rearch(srchbuf *bptr)
{
  uchar *ptr;

  while (bptr->tar_cur < bptr->tar_end)
    {
      if (comp(bptr->buf_end, bptr->tar_cur, bptr->tar_top))
	return true;
      bptr->buf_cur--;
      bptr->tar_cur++;
      for (ptr = bptr->tar_end - 1; ptr > bptr->tar_cur; ptr--)
	{
	  if (comp(bptr->tar_end, ptr, bptr->tar_cur + 1))
	    break;
	  bptr->buf_cur--;
	  bptr->tar_cur++;
	}
    }
  return false;
}

static bool (*prev_buffer_read)(void);

bool rearch(srchbuf *bptr)
{
  if (bptr->tar_cur < bptr->tar_end)
    bptr->tar_cur++;
  bptr->buf_cur--;
  do
    {
      if (bptr->tar_cur < bptr->tar_end)
	if (bound_rearch(bptr))
	  return true;
      if (back_rearch(bptr))
	return true;
      (void)bound_rearch_pre(bptr);
    }
  while ((*prev_buffer_read)());
  return false;
}

void rearch_init(srchbuf *bptr, bool (*buffer_read)(void))
{
  int size, i;
  skip *kptr;
  uchar *tptr, *tptr2, *bu;
  uchar buffer[256];

  prev_buffer_read = buffer_read;
  kptr = bptr->sk_top;
  tptr = bptr->tar_top;
  bu = buffer;
  while (kptr <= bptr->sk_end)
    {
      for (i = 0; i < 256; i++)
	{
	  *bu = i;
	  size = 0;
	  for (tptr2 = tptr; tptr2 <= bptr->tar_end; ++tptr2)
	    {
	      if (comp(tptr2, bu, buffer))
		break;
	      ++size;
	    }
	  if (tptr2 > bptr->tar_end)
	    {
	      --size;
	      for (tptr2 = bu; tptr2 >= buffer; --tptr2)
		{
		  if (comp(bptr->tar_top, tptr2, buffer))
		    break;
		  ++size;
		}
	    }
	  (*kptr)[i] = size;
	}
      size = bptr->tar_end - tptr + 1;
      for (tptr2 = bu + 1; tptr2 >= buffer; --tptr2)
	{
	  if (comp(bptr->tar_end, tptr2, buffer))
	    break;
	  ++size;
	}
      (*kptr)[256] = size;
      *bu++ = *tptr++;
      kptr++;
    }
  bptr->tar_cur = bptr->tar_end;
  bptr->buf_cur = bptr->buf_end + 1;
}

static inline int RPeekA(unsigned char *ptr)
{
register int trap asm("d0");

  BusErrorDetected = 0;
  __asm ("RPeekA_from::\n\t"
	 "moveq #0,%0\n\t"
	 "move.b %1,%0\n"
	 "RPeekA_resume::" : "=d" (trap) : "m" (*ptr));
  if (BusErrorDetected)
    trap = 0x100;
  return trap;
}

static inline int RPeekB(unsigned char *ptr)
{
register int trap asm("d0");

  BusErrorDetected = 0;
  __asm ("RPeekB_from::\n\t"
	 "moveq #0,%0\n\t"
	 "move.b %1,%0\n"
	 "RPeekB_resume::" : "=d" (trap) : "m" (*ptr));
  if (BusErrorDetected)
    trap = 0x100;
  return trap;
}

static bool comp(uchar *target, uchar *end, uchar *top)
{
  while (end >= top)
    if (RPeekA(target--) != RPeekB(end--))
      return false;
  return true;
}

/* EOF */
