/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/search.c,v $
 * $Author: kawamoto $
 * $Revision: 1.2 $
 * $Date: 1993/10/24 18:37:54 $
 * $Log: search.c,v $
 *	Revision 1.2  1993/10/24  18:37:54  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:43:19  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "search.h"

extern volatile char BusErrorDetected;

static bool comp(uchar *target, uchar *top, uchar *end);

static inline int SPeekC(unsigned char *ptr)
{
register int trap asm("d0");

  BusErrorDetected = 0;
  __asm ("SPeekC_from::\n\t"
	 "moveq #0,%0\n\t"
	 "move.b %1,%0\n"
	 "SPeekC_resume::" : "=d" (trap) : "m" (*ptr));
  if (BusErrorDetected)
    trap = 0x100;
  return trap;
}

static inline int back_comp(srchbuf *bptr)
{
  int num;
  uchar *ground;
  skip *skips;

  ground = bptr->buf_cur;
  skips = bptr->sk_end;
  while (skips >= bptr->sk_top)
    {
      if ((num = (*skips)[SPeekC(ground)]))
	return num;
      ground--;
      skips--;
    }
  return 0;
}

static inline bool back_search(srchbuf *bptr)
{
  int num;

  while (bptr->buf_cur <= bptr->buf_end)
    {
      if ((num = back_comp(bptr)) == 0)
	return true;
      bptr->buf_cur += num;
    }
  return false;
}

static inline bool bound_search_pre(srchbuf *bptr)
{
  int offset;
  uchar *ptr;

  offset = bptr->buf_cur - bptr->buf_end - 1;
  bptr->buf_cur = bptr->buf_top + offset;
  bptr->tar_cur = bptr->tar_end - offset;
  for (ptr = bptr->buf_end - bptr->tar_size + offset + 2; ptr <= bptr->buf_end; ptr++)
    {
      if (comp(bptr->tar_top, ptr, bptr->buf_end))
	return true;
      bptr->buf_cur++;
      bptr->tar_cur--;
    }
  return false;
}

static inline bool bound_search(srchbuf *bptr)
{
  uchar *ptr;

  while (bptr->tar_cur > bptr->tar_top)
    {
      if (comp(bptr->buf_top, bptr->tar_cur, bptr->tar_end))
	return true;
      bptr->buf_cur++;
      bptr->tar_cur--;
      for (ptr = bptr->tar_top + 1; ptr < bptr->tar_cur; ptr++)
	{
	  if (comp(bptr->tar_top, ptr, bptr->tar_cur - 1))
	    break;
	  bptr->buf_cur++;
	  bptr->tar_cur--;
	}
    }
  return false;
}

static bool (*next_buffer_read)(void);

bool search(srchbuf *bptr)
{
  if (bptr->tar_cur > bptr->tar_top)
    bptr->tar_cur--;
  bptr->buf_cur++;
  do
    {
      if (bptr->tar_cur > bptr->tar_top)
	if (bound_search(bptr))
	  return true;
      if (back_search(bptr))
	return true;
      (void)bound_search_pre(bptr);
    }
  while ((*next_buffer_read)());
  return false;
}

void search_init(srchbuf *bptr, bool (*buffer_read)(void))
{
  int size, i;
  skip *kptr;
  uchar *tptr, *tptr2, *bu;
  uchar buffer[256];

  next_buffer_read = buffer_read;
  kptr = bptr->sk_end;
  tptr = bptr->tar_end;
  bu = buffer + 255;
  while (kptr >= bptr->sk_top)
    {
      for (i = 0; i < 256; i++)
	{
	  *bu = i;
	  size = 0;
	  for (tptr2 = tptr; tptr2 >= bptr->tar_top; --tptr2)
	    {
	      if (comp(tptr2, bu, buffer + 255))
		break;
	      ++size;
	    }
	  if (tptr2 < bptr->tar_top)
	    {
	      --size;
	      for (tptr2 = bu; tptr2 <= buffer + 255; ++tptr2)
		{
		  if (comp(bptr->tar_top, tptr2, buffer + 255))
		    break;
		  ++size;
		}
	    }
	  (*kptr)[i] = size;
	}
      size = tptr - bptr->tar_top + 1;
      for (tptr2 = bu + 1; tptr2 <= buffer + 255; ++tptr2)
	{
	  if (comp(bptr->tar_top, tptr2, buffer + 255))
	    break;
	  ++size;
	}
      (*kptr)[256] = size;
      *bu-- = *tptr--;
      kptr--;
    }
  bptr->tar_cur = bptr->tar_top;
  bptr->buf_cur = bptr->buf_top - 1;
}

static inline int SPeekA(unsigned char *ptr)
{
register int trap asm("d0");

  BusErrorDetected = 0;
  __asm ("SPeekA_from::\n\t"
	 "moveq #0,%0\n\t"
	 "move.b %1,%0\n"
	 "SPeekA_resume::" : "=d" (trap) : "m" (*ptr));
  if (BusErrorDetected)
    trap = 0x100;
  return trap;
}

static inline int SPeekB(unsigned char *ptr)
{
register int trap asm("d0");

  BusErrorDetected = 0;
  __asm ("SPeekB_from::\n\t"
	 "moveq #0,%0\n\t"
	 "move.b %1,%0\n"
	 "SPeekB_resume::" : "=d" (trap) : "m" (*ptr));
  if (BusErrorDetected)
    trap = 0x100;
  return trap;
}

static bool comp(uchar *target, uchar *top, uchar *end)
{
  while (top <= end)
    if (SPeekA(target++) != SPeekB(top++))
      return false;
  return true;
}

/* EOF */
