/*
 * $Project: dedit Disk EDITor for X680x0 $
 * $Copyright: 1989-1993 by d(T.Kawamoto) $
 * $Source: /home/src/cvs/dedit/undel.c,v $
 * $Author: kawamoto $
 * $Revision: 1.4 $
 * $Date: 1995/05/08 01:04:36 $
 * $Log: undel.c,v $
 *	Revision 1.4  1995/05/08  01:04:36  kawamoto
 *	Version 2.26b
 *
 *	Revision 1.3  1994/04/23  11:36:51  kawamoto
 *	hLgC
 *
 *	Revision 1.2  1993/10/24  18:38:20  kawamoto
 *	*** empty log message ***
 *
 *	Revision 1.1  1993/10/24  17:43:42  kawamoto
 *	version 2.24 first cvs importing
 */

#include "dedit.h"
#include "console.h"
#include "error.h"
#include "dir.h"

static int fat(int (*)());
static int funcTable(int);
static void rev2(int, int);

static int lostLen, fatNo, clusterLen;
static char firstChar[2];
static direntry *wptrSave;
static int UNDELonly;

int UndelPre(direntry *wptr, int undelOnly)
{
  int i;

  if (wptr->atr & 0x08)
    return ERROR;
  if (wptr->fileName[0] == (char) 0xe5)
    {
      B_LOCATE(40, 29);
      B_PRINT("\33[37mꕶ H ");
      i = GetName(firstChar, 2, 0);
      B_LOCATE(0, 29);
      B_ERA_AL();
      B_CUROFF();
      if (i == ERROR)
	return ERROR;
    }
  else if (undelOnly)
    return ERROR;
  else
    firstChar[0] = 0;
  lostLen = (wptr->fileLen[3] << 24) + (wptr->fileLen[2] << 16) +
	    (wptr->fileLen[1] << 8) + wptr->fileLen[0];
  clusterLen = DPBbuf.byte << DPBbuf.shift;
  fatNo = (wptr->fatNo[1] << 8) + wptr->fatNo[0];
  wptrSave = wptr;
  UNDELonly = undelOnly;
  return 0;
}

void Undel()
{
  fat(funcTable);
}

static int dumpConts(void);
static int loadFatTable(void);
static void saveFatTable(void);
#define NOP		0
#define NEXT_CLUSTER	1
#define LAST_CLUSTER	2
#define HEAD_CLUSTER	3
#define CLUSTER_NO_IN	4
#define CLUSTER_NO_VAR	5
#define CONTS		8
static int funcCLUSTER(int);
static void select(int, int);
static int check(void);
static void funcSELECT(int);
static void funcDESELECT(int);
static void funcAUTO(int);
static int funcCONTS(void);
static void printBytes(void);
static void fDump(void), fDump2(int, int);
static void fatPre(void), fatPost(void);
static void conv(int , uchar *);
static uchar *convSub(int, uchar *);
static int hex(int);

static uchar *ptr, *fatptr;
static int fatDnum, headOffset, endOffset;
static ushort *fatDptr, *savedFatDptr;
static ushort asterCluster, asterSize;
static int savedCounter, savedFileLen;
static int locX, locY;
static int lLocX, lLocY;
static int adr, top, end;

static int fat(int (*funcKeys)())
{
  int c, ret;

  if (loadFatTable())
    return 0;
  B_LOCATE(0,2);
  B_CLR_ED();
  B_LOCATE(39, 3);
  B_PRINT("\33[36m[[[ \33[35m \33[36m]]]");
  fatPre();
  (*funcKeys)(FUNC_PRE);
  headOffset = (fatNo & 0xfffffff0) - 128;
  if (headOffset < 0)
    headOffset = 0;
  if (headOffset > endOffset)
    headOffset = endOffset;
  fDump();
  lLocX = locX = 11 + (fatNo & 15) * 5;
  lLocY = locY = 8 + (fatNo >> 4) - (headOffset >> 4);
  B_CUROFF();
  rev2(locX, locY);
  while (1)
    {
      switch (c = GetKey())
        {
	case 0x3d:/* RIGHT */
	  if (fatNo + 1 >= fatDnum)
	    continue;
	  if (locX < 86)
	    {
	      ++fatNo;
	      locX += 5;
	      break;
	    }
	  fatNo -= 15;
	  locX = 11;
	case 0x3e:/* DOWN */
	  if (fatNo + 16 >= fatDnum)
	    continue;
	  if (locY < 23)
	    {
	      fatNo += 16;
	      ++locY;
	      break;
	    }
	  if (headOffset == endOffset)
	    continue;
	  if (fatNo + 16 >= fatDnum)
	    continue;
	  fatNo += 16;
	  headOffset += 16;
	  rev2(lLocX, lLocY);
	  Scroll(8, 23, 1, 8);
	  fDump2(headOffset + 240, 23);
	  rev2(lLocX, lLocY);
	  break;
	case 0x38:/* ROLL UP */
	  if (CtrlKey)
	    {
	      c = 0x68;/* F6 */
	      goto function;
	    }
	  if (OPT1Key)
	    {
	      c = 0x6B;/* F9 */
	      goto function;
	    }
	  if (headOffset == endOffset)
	    continue;
	  if (fatNo + 16 >= fatDnum)
	    continue;
	  fatNo += 16 * 16;
	  headOffset += 16 * 16;
	  if (headOffset > endOffset)
	    {
	      fatNo -= headOffset - endOffset;
	      headOffset = endOffset;
	    }
	  if (fatNo >= fatDnum)
	    {
	      headOffset -= 16;
	      fatNo -= 16;
	    }
	  rev2(lLocX, lLocY);
	  fDump();
	  rev2(lLocX, lLocY);
	  break;
	case 0x3b:/* LEFT */
	case 0x0f:/* BS */
	  if (fatNo - 1 < 2)
	    continue;
	  if (locX > 11)
	    {
	      --fatNo;
	      locX -= 5;
	      break;
	    }
	  fatNo += 15;
	  locX = 86;
	case 0x3c:/* UP */
	  if (fatNo - 16 < 2)
	    continue;
	  if (locY >= 9)
	    {
	      fatNo -= 16;
	      --locY;
	      break;
	    }
	  if (headOffset == 0)
	    continue;
	  if (fatNo - 16 < 2)
	    continue;
	  fatNo -= 16;
	  headOffset -= 16;
	  rev2(lLocX, lLocY);
	  Scroll(8, 23, -1, 8);
	  fDump2(headOffset, 8);
	  rev2(lLocX, lLocY);
	  break;
	case 0x39:/* ROLL DOWN */
	  if (CtrlKey)
	    {
	      c = 0x69;/* F7 */
	      goto function;
	    }
	  if (OPT1Key)
	    {
	      c = 0x6C;/* F10 */
	      goto function;
	    }
	  if (headOffset == 0)
	    continue;
	  if (fatNo - 16 < 2)
	    continue;
	  fatNo -= 16 * 16;
	  headOffset -= 16 * 16;
	  if (headOffset < 0)
	    {
	      fatNo -= headOffset;
	      headOffset = 0;
	    }
	  if (fatNo < 2)
	    {
	      headOffset += 16;
	      fatNo += 16;
	    }
	  rev2(lLocX, lLocY);
	  fDump();
	  rev2(lLocX, lLocY);
	  break;
	case 0x63:/* F1 */
	case 0x64:/* F2 */
	case 0x65:/* F3 */
	case 0x66:/* F4 */
	case 0x67:/* F5 */
	case 0x68:/* F6 */
	case 0x69:/* F7 */
	case 0x6A:/* F8 */
	case 0x6B:/* F9 */
	case 0x6C:/* F10 */
	function:
	  rev2(locX, locY);
	  if ((ret = (*funcKeys)(ShiftKey ? (c - 0x62 + 10) : (c - 0x62))) != 0)
	    {
	      if (ret == 2)
		saveFatTable();
	      fatPost();
	      return ret - 1;
	    }
	  B_CUROFF();
	  rev2(locX, locY);
	  continue;
	case 0x01:/* ESC */
	  CheckShift();
	  fatPost();
	  return 0;
	default:
	  continue;
	}
      rev2(lLocX, lLocY);
      rev2(locX, locY);
      lLocX = locX;
      lLocY = locY;
    }
}

static int funcTable(int keyNo)
{
  switch (keyNo)
    {
    case FUNC_PRE:
      B_LOCATE(0, 4);
      B_ERA_AL();
      B_LOCATE(20, 4);
      B_PRINT("\33[31m   hCu                     IoCg\33[33m");
      B_LOCATE(54, 5);
      B_PRINT("\33[31mcoCg\33[33m");
      B_LOCATE(34, 4);
      B_COLOR(7);
      B_PUTC(CurDrive + ('A'-1));
      B_PUTC(':');
      printBytes();
      B_CUROFF();
      FNCKEYST(3, " @s");
      FNCKEYST(4, MesFKeyBar);
      FNCKEYST(5, " @e");
      FNCKEYST(6, " I@");
      FNCKEYST(7, " I");
      FNCKEYST(8, " @");
      FNCKEYST(9, MesFKeyNxtClst);
      FNCKEYST(10, MesFKeyLstClst);
      FNCKEYST(16, " @");
      FNCKEYST(17, " O");
      FNCKEYST(19, MesFKeyHdClst);
      FNCKEYST(20, MesFKeyClstNo);
      break;
    case 3:
      if (savedCounter == 0)
	{
	  B_LOCATE(36, 29);
	  B_PRINT("\33[36mIĂ܂B");
	  (void)GetKey();
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	  return 0;
	}
      return 2;
    case 5:
      return funcCONTS();
    case 6:
      funcSELECT(NOP);
      break;
    case 7:
      funcSELECT(NEXT_CLUSTER);
      break;
    case 8:
      funcAUTO(NEXT_CLUSTER);
      break;
    case 9:
      funcCLUSTER(NEXT_CLUSTER);
      break;
    case 10:
      funcCLUSTER(LAST_CLUSTER);
      break;
    case 16:
      funcDESELECT(0);
      break;
    case 17:
      funcDESELECT(2);
      break;
    case 19:
      funcCLUSTER(HEAD_CLUSTER);
      break;
    case 20:
      funcCLUSTER(CLUSTER_NO_IN);
      break;
    }
  return 0;
}

static int funcCONTS()
{
  int ret;

  if (fatNo < 2)
    return 0;
  B_LOCATE(0,4);
  B_CLR_ED();
  B_CUROFF();
  Clear23();
  if ((ret = dumpConts()) != 0)
    return ret;
  fatPre();
  funcTable(-1);
  fDump();
  return 0;
}

static int dumpConts()
{
  int d;
  uchar c;

  B_LOCATE(0,4);
  B_CLR_ED();
  B_CUROFF();
  Window(11, 8, 74, 16);
  YLine(19, 8, 16);
  YLine(67, 8, 16);
  B_LOCATE(0, 4);
  B_ERA_AL();
  B_LOCATE(20, 4);
  B_PRINT("\33[31m   hCu                     IoCg\33[33m");
  B_LOCATE(20, 5);
  B_PRINT("\33[31mNX^ mo.                     coCg\33[33m");
  B_LOCATE(34, 4);
  B_COLOR(7);
  B_PUTC(CurDrive + ('A'-1));
  B_PUTC(':');
  B_LOCATE(34, 5);
  B_COLOR(7);
  B_PUTC('$');
  for (d = 12; d >= 0; d -= 4)
    PutHex(fatNo >> d);
  printBytes();
  B_LOCATE(11, 6);
  B_COLOR(3);
  B_PRINT(MesAddress);
  B_LOCATE(25, 25);
  B_PRINT("\33[35mXN[  \33[36m[\33[37mROLL UP\33[36m] [\33[37mROLL DOWN\33[36m] [\33[37m\33[36m] [\33[37m\33[36m]");
  B_LOCATE(32, 26);
  B_PRINT(MesRetESC);
  B_CUROFF();
  FNCKEYST(4, "e[u");
  FNCKEYST(5, MesFKeyBar);
  top = (int)Malloc(clusterLen);
  if (diskred(0, (uchar *)top, CurDrive, FATnoToSector(fatNo), DPBbuf.sec + 1))
    {
      Post();
      exit(0);
    }
  B_CUROFF();
  end = top + clusterLen - 256;
  adr = top;
  Dump(adr, top);
  while (1)
    {
      B_CUROFF();
      switch (c = GetKey())
	{
	case 0x3e:/* DOWN */
	  if (adr + 16 > end)
	    continue;
	  adr += 16;
	  Scroll(8, 23, 1, 8);
	  ScrollKanjiFlag(1);
	  Dump2(adr, top, 15);
	  continue;
	case 0x3c:/* UP */
	  if (adr - 16 < top)
	    continue;
	  adr -= 16;
	  Scroll(8, 23, -1, 8);
	  ScrollKanjiFlag(-1);
	  for (d = 0; d < 16; ++d)
	    if (Dump2(adr, top, d))
	      break;
	  continue;
	case 0x38:/* ROLL UP */
	  if (OPT1Key)
	    goto F9;
	  if (CtrlKey)
	    continue;
	  if ((adr += 256) > end)
	    adr = end;
	  Dump(adr, top);
	  continue;
	case 0x39:/* ROLL DOWN */
	  if (OPT1Key)
	    goto F10;
	  if (CtrlKey)
	    continue;
	  if ((adr -= 256) < top)
	    adr = top;
	  Dump(adr, top);
	  continue;
	case 0x65:/* F3 */
	  if (ShiftKey)
	    continue;
	  d = 2;
	  B_LOCATE(0,2);
	  goto escape;
	case 0x66:/* F4 */
	  if (ShiftKey)
	    continue;
	  d = 0;
	  B_LOCATE(0,4);
	  goto escape;
	case 0x68:/* F6 */
	  if (ShiftKey)
	    funcDESELECT(1);
	  else
	    funcSELECT(NOP + CONTS);
	  continue;
	case 0x69:/* F7 */
	  if (ShiftKey)
	    funcDESELECT(3);
	  else
	    funcSELECT(NEXT_CLUSTER + CONTS);
	  continue;
	case 0x6A:/* F8 */
	  if (ShiftKey)
	    continue;
	  funcAUTO(NEXT_CLUSTER + CONTS);
	  continue;
	case 0x6B:/* F9 */
	F9:
	  funcCLUSTER(ShiftKey ?(HEAD_CLUSTER + CONTS):(NEXT_CLUSTER + CONTS));
	  continue;
	case 0x6C:/* F10 */
	F10:
	  funcCLUSTER(ShiftKey ?(CLUSTER_NO_IN + CONTS):(LAST_CLUSTER + CONTS));
	  continue;
	case 0x01:/* ESC */
	  d = 1;
	  B_LOCATE(0,2);
	escape:
	  B_CLR_ED();
	  B_CUROFF();
	  Clear23();
	  free((char *)top);
	  CheckShift();
	  return d;
	default:
	  continue;
	}
    }
}

static int funcCLUSTER(int type)
{
  int d = 0;

  switch (type & 7)
    {
    case NEXT_CLUSTER:
      if (fatDptr[fatNo] >= fatDnum)
	return ERROR;
      if (fatDptr[fatNo] == 0)
	{
	  for (d = fatNo + 1; d < fatDnum; ++d)
	    if (fatDptr[d] == 0)
	      goto cluster;
	  return ERROR;
	}
      d = fatDptr[fatNo];
      break;
    case LAST_CLUSTER:
      if (fatNo < 2)
	return ERROR;
      if (fatDptr[fatNo] == 0)
	{
	  for (d = fatNo - 1; d > 0; --d)
	    if (fatDptr[d] == 0)
	      goto cluster;
	  return ERROR;
	}
      if ((fatDptr[fatNo] != 0xffff) && (fatDptr[fatNo] >= fatDnum))
	return ERROR;
      for (d = 2; d < fatDnum; ++d)
	if (fatDptr[d] == fatNo)
	  goto cluster;
      return ERROR;
    case HEAD_CLUSTER:
      d = 2;
      break;
    case CLUSTER_NO_IN:
      B_LOCATE(38, 28);
      B_PRINT("\33[37mNX^ m H $");
      d = GetNum(16, 4, fatNo);
      B_LOCATE(0, 28);
      B_ERA_AL();
      if ((d == ERROR) || (d >= fatDnum) || (d < 2))
	return ERROR;
      break;
    case CLUSTER_NO_VAR:
      d = fatNo;
      break;
    }
cluster:
  fatNo = d;
  d = (d & 0xfff0) - 128;
  if (d < 0)
    d = 0;
  if (d > endOffset)
    d = endOffset;
  lLocY = locY = (fatNo >> 4) - (d >> 4) + 8;
  lLocX = locX = (fatNo & 0xf) *	5 + 11;
  if (d != headOffset)
    {
      headOffset = d;
      if (type < CONTS)
	fDump();
    }
  if (type >= CONTS)
    {
      if (diskred(0, (uchar *)top, CurDrive, FATnoToSector(fatNo), DPBbuf.sec + 1))
	{
	  Post();
	  exit(0);
	}
      B_LOCATE(34, 5);
      B_COLOR(7);
      B_PUTC('$');
      for (d = 12; d >= 0; d -= 4)
	PutHex(fatNo >> d);
      B_CUROFF();
      Dump(adr, top);
    }
  return 0;
}

static void select(int type, int length)
{
  int i;

  if (lostLen != 0x7fffffff)
    lostLen -= length;
  if ((i = (savedFileLen % clusterLen)) != 0)
    savedFileLen += clusterLen - i;
  savedFileLen += length;
  savedFatDptr[fatNo] = ++savedCounter;
  if (type < CONTS)
    fDump2(fatNo & 0xfffffff0, locY);
}

static int check()
{
  int i;

  if (savedFatDptr[fatNo])
    return ERROR;
  if (UNDELonly)
    {
      if (fatDptr[fatNo])
	return ERROR;
    }
  else
    {
      for (i = 2; i < fatDnum; ++i)
	if (fatDptr[i] == fatNo)
	  break;
      if ((i < fatDnum) && (savedFatDptr[i] == 0))
	return ERROR;
    }
  return 0;
}

static void funcSELECT(int type)
{
  int d, yn = 'Y';

  if (fatNo < 2)
    return;
  if (check() == ERROR)
    {
      if (savedFatDptr[fatNo])
	{
	  B_LOCATE(41, 29);
	  B_PRINT("\33[36mIς݂łB");
	}
      else
	{
	  B_LOCATE(42, 29);
	  B_PRINT("\33[36mgpłB");
	}
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      return;
    }
  if (lostLen < clusterLen)
    {
      if (lostLen)
	{
	  B_LOCATE(9, 29);
	  B_PRINT("\33[36mcTCYȂȂ܂B\33[37m\ʂ̃oCgőI܂iy/njH ");
	  yn = GetASC();
	  yn = toupper(yn);
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	}
      else
	yn = 'N';
      if (yn == 'Y')
	d = lostLen;
      else if (yn == 'N')
	{
	  B_LOCATE(29, 29);
	  B_PRINT("\33[37mȌANX^TCYPʂőI܂B");
	  B_CUROFF();
	  WaitForAMoment(2);
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	  asterSize = lostLen ? lostLen :
		      (clusterLen * 2 - (savedFileLen % clusterLen));
	  asterCluster = fatNo;
	  lostLen = 0x7fffffff;
	  d = clusterLen;
	}
      else
	return;
    }
  else
    d = clusterLen;
  select(type, d);
  B_LOCATE(36, 29);
  B_PRINT("\33[37mI܂B");
  B_CUROFF();
  WaitForAMoment(1);
  B_LOCATE(0, 29);
  B_ERA_AL();
  if ((lostLen != 0) && (type & 7) && funcCLUSTER(type))
    {
      B_LOCATE(29, 29);
      B_PRINT("\33[36m̃NX^Ɉڂ܂łB");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
    }
  printBytes();
}

static void funcDESELECT(int flag)
{
  int length, i;

  if (savedCounter == 0)
    {
      B_LOCATE(35, 29);
      B_PRINT("\33[36mINX^L܂B");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
      return;
    }
  for (i = 2; savedFatDptr[i] != savedCounter; ++i) 
    ;
  if (lostLen == 0)
    {
      length = savedFileLen % clusterLen;
      lostLen += length;
    }
  else if (lostLen == 0x7fffffff)
    {
      if (i == asterCluster)
	{
	  if (asterSize < clusterLen)
	    {
	      length = clusterLen;
	      lostLen = asterSize;
	    }
	  else
	    {
	      length = asterSize;
	      lostLen = 0;
	    }
	}
      else
	length = clusterLen;
    }
  else
    {
      length = clusterLen;
      lostLen += length;
    }
  savedFileLen -= length;
  savedFatDptr[i] = 0;
  --savedCounter;
  if (flag > 1)
    {
      fatNo = i;
      funcCLUSTER((flag == 3) ? CLUSTER_NO_VAR + CONTS : CLUSTER_NO_VAR);
    }
  else
    {
      B_LOCATE(32, 29);
      B_PRINT("\33[37mPNX^܂B");
      B_CUROFF();
      WaitForAMoment(1);
      B_LOCATE(0, 29);
      B_ERA_AL();
    }
  if ((flag & 1) == 0)
    fDump();
  printBytes();
}

static void funcAUTO(int type)
{
  if (fatNo < 2)
    return;
  while (1)
    {
      if (lostLen == 0)
	break;
      if (check() == ERROR)
	{
	  if (savedFatDptr[fatNo])
	    {
	      B_LOCATE(33, 29);
	      B_PRINT("\33[36mIς݂łBXLbv܂B");
	      (void)GetKey();
	      B_LOCATE(0, 29);
	      B_ERA_AL();
	    }
	  else
	    {
	      B_LOCATE(36, 29);
	      B_PRINT("\33[36mgpłBf܂B");
	      (void)GetKey();
	      B_LOCATE(0, 29);
	      B_ERA_AL();
	      printBytes();
	      return;
	    }
	}
      select(type, (lostLen < clusterLen) ? lostLen : clusterLen);
      if (lostLen == 0)
	break;
      if (funcCLUSTER(type))
	{
	  B_LOCATE(29, 29);
	  B_PRINT("\33[36mcNX^L܂B");
	  (void)GetKey();
	  B_LOCATE(0, 29);
	  B_ERA_AL();
	  break;
	}
    }
  B_LOCATE(37, 29);
  B_PRINT("\33[37m܂B");
  B_CUROFF();
  WaitForAMoment(2);
  B_LOCATE(0, 29);
  B_ERA_AL();
  printBytes();
}

static int loadFatTable()
{
  int i, j, size;

  size = DPBbuf.fatlen;
  fatptr = Malloc(size << 10);
  if (diskred(0, fatptr, CurDrive, DPBbuf.fatsec, size))
    {
      free(fatptr);
      return 1;
    }
  fatDnum = DPBbuf.maxfat - 1;
  endOffset = (fatDnum & 0xfff0) - 240;
  if (endOffset < 0)
    endOffset = 0;
  switch (Is2Bytes)
    {
    case 0:
      fatDptr = (ushort *)Malloc(fatDnum << 1);
      ptr = fatptr;
      j = (fatDnum + 1) & 0xfffffffe;
      for (i = 0; i < j; ++i)
	{
	  fatDptr[i] = *ptr++;
	  fatDptr[i] += (*ptr & 0xf) << 8;
	  if (fatDptr[i] > 0xff6)
	    fatDptr[i] += 0xf000;
	  fatDptr[++i] = *ptr++ >> 4;
	  fatDptr[i] += *ptr++ << 4;
	  if (fatDptr[i] > 0xff6)
	    fatDptr[i] += 0xf000;
	}
      break;
    case 1:
    case 2:
      if (fatptr[0] == 0xf0)
	{
	  Is2Bytes = 2;
	  fatDptr = (ushort *)Malloc(fatDnum << 1);
	  ptr = fatptr;
	  for (i = 0; i < fatDnum; ++i)
	    {
	      fatDptr[i] = *ptr++;
	      fatDptr[i] += (*ptr++) << 8;
	    }
	}
      else
	{
	  Is2Bytes = 1;
	  fatDptr = (ushort *)fatptr;
	}
      break;
    }
  savedFatDptr = (ushort *)Malloc(fatDnum << 1);
  j = (fatDnum + 1) & 0xfffffffe;
  for (i = 0; i < j; ++i)
    savedFatDptr[i] = 0;
  savedCounter = 0;
  savedFileLen = 0;
  return 0;
}

static void saveFatTable()
{
  int i, j, last;

  if (savedCounter == 0)
    return;
  last = 0xffff;
  for (i = savedCounter; i > 0; --i)
    {
      for (j = 2; j < fatDnum; ++j)
	if (savedFatDptr[j] == i)
	  break;
      fatDptr[j] = last;
      last = j;
    }
  switch (Is2Bytes)
    {
    case 0:
      ptr = fatptr;
      j = (fatDnum + 1) & 0xfffffffe;
      for (i = 0; i < j; ++i)
	{
	  *ptr++ = fatDptr[i];
	  *ptr = (fatDptr[i] >> 8) & 0xf;
	  *ptr++ += fatDptr[++i] << 4;
	  *ptr++ = fatDptr[i] >> 4;
	}
      break;
    case 1:
      break;
    case 2:
      ptr = fatptr;
      for (i = 0; i < fatDnum; ++i)
	{
	  *ptr++ = fatDptr[i];
	  *ptr++ = fatDptr[i] >> 8;
	}
      break;
    }
  if (diskwrt(0, fatptr, CurDrive, DPBbuf.fatsec, DPBbuf.fatlen))
    {
      B_LOCATE(36, 29);
      B_PRINT("\33[36m݂Ɏs܂B");
      (void)GetKey();
      B_LOCATE(0, 29);
      B_ERA_AL();
    }
  ToParent(&i);
  readDirec(0);
  wptrSave->fileName[0] = firstChar[0];
  if (wptrSave->atr & 0x20)
    {
      wptrSave->fileLen[0] = savedFileLen;
      wptrSave->fileLen[1] = savedFileLen >> 8;
      wptrSave->fileLen[2] = savedFileLen >> 16;
      wptrSave->fileLen[3] = savedFileLen >> 24;
    }
  wptrSave->fatNo[0] = last;
  wptrSave->fatNo[1] = last >> 8;
  writeDirec();
  ToChild(wptrSave, i, 1);
}

static void printBytes()
{
  int i;

  B_LOCATE(67, 4);
  B_COLOR(7);
  B_PUTC('$');
  for (i = 28; i >= 0; i -= 4)
    PutHex(savedFileLen >> i);
  B_LOCATE(67, 5);
  B_COLOR(7);
  if (lostLen == 0x7fffffff)
    B_PRINT("*********");
  else
    {
      B_PUTC('$');
      for (i = 28; i >= 0; i -= 4)
	PutHex(lostLen >> i);
    }
}

static void fDump()
{
  int locX, locY;
  int offset;

  offset = headOffset;
  locX = 6;
  for (locY = 8; locY < 24; ++locY)
    {
      conv(offset, temp);
      Print(locX, locY, temp);
      offset += 16;
    }
}

static void fDump2(int offset, int locY)
{
  conv(offset, temp);
  Print(6, locY, temp);
}

static void rev2(int locX, int locY)
{
  struct TREVPTR txRev;

  txRev.vram_page = 3;
  txRev.x = locX << 3;
  txRev.y = locY << 4;
  txRev.x1 = 32;
  txRev.y1 = 16;
#ifdef MOUSE
  MS_CUROF();
#endif
  TXREV(&txRev);
#ifdef MOUSE
  MS_CURON();
#endif
}

static void fatPre()
{
  B_LOCATE(0,4);
  B_CLR_ED();
  B_CUROFF();
  Window(6, 8, 84, 16);
  YLine(10, 8, 16);
  B_LOCATE(5, 6);
  B_PRINT("\33[32m׽No  +0   +1   +2   +3   +4   +5   +6   +7   +8   +9   +A   +B   +C   +D   +E   +F\33[33m");
  B_LOCATE(14, 25);
  B_PRINT(MesCursScrl);
  B_PRINT(MesCursLURD);
  B_LOCATE(32, 26);
  B_PRINT(MesRetESC);
  B_COLOR(3);
}

static void fatPost()
{
  B_LOCATE(0,2);
  B_CLR_ED();
  B_CUROFF();
  Clear23();
  NulFuncKey();
  free(fatptr);
  if (Is2Bytes != 1)
    free(fatDptr);
  free(savedFatDptr);
  free(ptr);
}

static void conv(int offset, uchar *to)
{
  int i;

  if (offset >= fatDnum)
    {
      for (i = 0; i < 84; i++)
	*to++ = ' ';
      *to = '\0';
      return;
    }
  *to++ = hex(offset >> 12);
  *to++ = hex(offset >> 8);
  *to++ = hex(offset >> 4);
  *to++ = hex(offset);
  for (i = 0; (i < 16) && (offset < fatDnum); ++i)
    to = convSub(offset++, to);
  for ( ; i < 16; ++i)
    {
      *to++ = ' ';
      *to++ = ' ';
      *to++ = ' ';
      *to++ = ' ';
      *to++ = ' ';
    }
  *to = '\0';
}

static uchar *convSub(int number, uchar *to)
{
static int flag = 0;
  int next;

  next = fatDptr[number];
  if (flag)
    {
      flag = 0;
      return to;
    }
  *to++ = ' ';
  if (savedFatDptr[number])
    {
      *to++ = '*';
      *to++ = 0x91;
      *to++ = 0x49;
      *to++ = '*';
    }
  else if (number == 0 || number == 1)
    {
      flag = 1;
      switch (DPBbuf.ide)
	{
	case 0xea:
	  *to++ = '2';
	  *to++ = 'H';
	  *to++ = 'T';
	  *to++ = ' ';
	  *to++ = '1';
	  *to++ = '.';
	  *to++ = '6';
	  *to++ = 'M';
	  *to++ = ' ';
	  break;
	case 0xeb:
	  *to++ = '2';
	  *to++ = 'H';
	  *to++ = 'S';
	  *to++ = ' ';
	  *to++ = '1';
	  *to++ = '.';
	  *to++ = '4';
	  *to++ = '4';
	  *to++ = 'M';
	  break;
	case 0xec:
	  *to++ = '2';
	  *to++ = 'H';
	  *to++ = 'D';
	  *to++ = 'E';
	  *to++ = '1';
	  *to++ = '.';
	  *to++ = '4';
	  *to++ = '4';
	  *to++ = 'M';
	  break;
	case 0xf0:
	  *to++ = 'I';
	  *to++ = 'B';
	  *to++ = 'M';
	  *to++ = ' ';
	  *to++ = 0x82;
	  *to++ = 0x6c;
	  *to++ = 0x82;
	  *to++ = 0x6e;
	  *to++ = ' ';
	  break;
	case 0xf4:
	  *to++ = 'S';
	  *to++ = 'C';
	  *to++ = 'S';
	  *to++ = 'I';
	  *to++ = ' ';
	  *to++ = 'D';
	  *to++ = 'A';
	  *to++ = 'T';
	  *to++ = ' ';
	  break;
	case 0xf5:
	  *to++ = 'S';
	  *to++ = 'C';
	  *to++ = 'S';
	  *to++ = 'I';
	  *to++ = 'C';
	  *to++ = 'D';
	  *to++ = 'R';
	  *to++ = 'O';
	  *to++ = 'M';
	  break;
	case 0xf6:
	  *to++ = 'S';
	  *to++ = 'C';
	  *to++ = 'S';
	  *to++ = 'I';
	  *to++ = ' ';
	  *to++ = 0x82;
	  *to++ = 0x6c;
	  *to++ = 0x82;
	  *to++ = 0x6e;
	  break;
	case 0xf7:
	  *to++ = 'S';
	  *to++ = 'C';
	  *to++ = 'S';
	  *to++ = 'I';
	  *to++ = ' ';
	  *to++ = 'H';
	  *to++ = 'D';
	  *to++ = 'D';
	  *to++ = ' ';
	  break;
	case 0xf8:
	  *to++ = 'H';
	  *to++ = 'A';
	  *to++ = 'R';
	  *to++ = 'D';
	  *to++ = ' ';
	  *to++ = 'D';
	  *to++ = 'I';
	  *to++ = 'S';
	  *to++ = 'K';
	case 0xf9:
	  *to++ = 'R';
	  *to++ = 'A';
	  *to++ = 'M';
	  *to++ = ' ';
	  *to++ = 'D';
	  *to++ = 'I';
	  *to++ = 'S';
	  *to++ = 'K';
	  *to++ = ' ';
	  break;
	case 0xfa:
	  *to++ = '2';
	  *to++ = 'H';
	  *to++ = 'Q';
	  *to++ = ' ';
	  *to++ = '1';
	  *to++ = '.';
	  *to++ = '4';
	  *to++ = '4';
	  *to++ = 'M';
	  break;
	case 0xfb:
	  *to++ = '2';
	  *to++ = 'D';
	  *to++ = 'D';
	  *to++ = ' ';
	  *to++ = '6';
	  *to++ = '4';
	  *to++ = '0';
	  *to++ = 'K';
	  *to++ = ' ';
	  break;
	case 0xfc:
	  *to++ = '2';
	  *to++ = 'D';
	  *to++ = 'D';
	  *to++ = ' ';
	  *to++ = '7';
	  *to++ = '2';
	  *to++ = '0';
	  *to++ = 'K';
	  *to++ = ' ';
	  break;
	case 0xfd:
	  *to++ = '2';
	  *to++ = 'H';
	  *to++ = 'C';
	  *to++ = ' ';
	  *to++ = '1';
	  *to++ = '.';
	  *to++ = '2';
	  *to++ = 'M';
	  *to++ = ' ';
	  break;
	case 0xfe:
	  *to++ = '2';
	  *to++ = 'H';
	  *to++ = 'D';
	  *to++ = ' ';
	  *to++ = '1';
	  *to++ = '.';
	  *to++ = '2';
	  *to++ = 'M';
	  *to++ = ' ';
	  break;
	default:
	  *to++ = ' ';
	  *to++ = 0x96;
	  *to++ = 0xa2;
	  *to++ = ' ';
	  *to++ = 0x8a;
	  *to++ = 0x6d;
	  *to++ = 0x94;
	  *to++ = 0x46;
	  *to++ = ' ';
	  break;
	}
    }
  else if (next >= fatDnum)
    {
      switch (next)
	{
	case 0xfff7:
	  *to++ = ' ';
	  *to++ = 0x8e;
	  *to++ = 0x80;
	  *to++ = ' ';
	  break;
	case 0xffff:
	  *to++ = ' ';
	  *to++ = 0x8f;
	  *to++ = 0x49;
	  *to++ = ' ';
	  break;
	default:
	  *to++ = ' ';
	  *to++ = '?';
	  *to++ = '?';
	  *to++ = ' ';
	  break;
	}
    }
  else if (next == 0)
    {
      *to++ = ' ';
      *to++ = 0x8b;
      *to++ = 0xf3;
      *to++ = ' ';
    }
  else
    {
      *to++ = hex(next >> 12);
      *to++ = hex(next >> 8);
      *to++ = hex(next >> 4);
      *to++ = hex(next);
    }
  return to;
}

static int hex(int number)
{
  number &= 0xf;
  return (number < 10) ? number + '0' : number + ('A' - 10);
}
